unit UGenePrincess;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GLAnimatedSprite, GLScene,
  GLCoordinates, GLObjects, GLMaterial, GLCadencer, GLWin32Viewer,
  GLCrossPlatform, BaseClasses, Vcl.ExtCtrls, PNGImage, JPeg, GlCompositeImage,
  GLFilePNG, GLFileTGA, TGA, GLTexture, GLHUDObjects, Math, GLVectorFileObjects,
  GLGeomObjects, GLFullScreenViewer,mmsystem, Vcl.MPlayer, Vcl.StdCtrls,
  GLSound, GLSMWaveOut, Bass, GLBitmapFont, GLWindowsFont;

type
  levblock=record
    fh:integer;
    ch:real;
    bch:real; //basic ceiling height (for crushers)
    x1,x2:integer;
    crusher:boolean;
    pit:boolean;
    spd:real;
    ky:integer;
    w:real;
  end;
  effect=record
    x,y:real;
    aframe:integer;
    spriten:string;
    w,h:real;
    alive:boolean;
  end;
  metascreen=record
    Width,Height:integer;
  end;
  missile=record
    x,y,kx,ky,spd:real;
    spdy:real;
    grav:boolean;
    alive:boolean;
    dmg:integer;
    bu:boolean;
    brad:real;
    d:real;
    name:string;
  end;
  player=record
    x,y:real; //coords
    px,py:real; //previous coords
    rx,ry:real;
    kx,ky:real; //movement
    ix,iy:real; //impulses; iy reacts to gravity, ix - to friction,
                //both modified by kx and ky
    ixmax,iymax:integer; //absolute values of maximum ix and iy
    state:integer; //state 0 - stands, 1 - in air, 2 - hits, 3 - dies,
                         //4 - morphs, 5 - walks left, 6 - walks right
    lvl,plevel:integer; //player level (to get correct sprites)
    hp,hpmax:integer;
    xp,xpreq:integer; //xp and requirement to reach next level
    eng,engmax:real;
    spd:integer;
    paframe:integer;
    face:integer; //1 - left, 0 - right
    strength,speed,intelligence:integer;
    hawkfall:boolean; //indicates if player will land with dealing damage
    hitrec:integer;
    hitrecbase:integer;
    hitstate:integer;
    shield:integer;
    morph:integer;
    invuln:boolean;
    foix:integer; //counter of forsed ix state
    ixtf:real;
    kxtf:real;
    pushed:integer;
    wkdir:integer; //0 - left, 1 - right, -1 - stop
    ondeco:boolean;
    lives:integer;
  end;
  enemy=record
    desx,desy,x,y:real;
    kx,ky:real;
    ix,iy:real; //analogical to player's ix,iy for enemies with complex movement
    alive:boolean;
    tp:integer; //enemy id in e<id>_<state>
    pattern:integer; //way of movement
    //0 - stands
    //1 - moves back and forth
    //2 - sinusoid flight when player is near
    x1,x2,y1,y2:real; //trajectory coords
    sk:real; //sinusoidal coefficient
    attack:integer; //damage inflicted
    atype:integer; //attack type
    //1 - close combat
    //2 - linear
    //3 - missile
    //4 - area
    size,sizex,sizey:real;
    state:integer; //0 - normal, 1 - attack, 2 - death, 3 - move
    aggr:integer;
    xpval:integer;
    hp,hpmax:integer;
    blink:integer;
    rectime:integer; //recharge time
    ac:integer; //attack chance
    deatheffect:string;
    grav:boolean; //is this enemy affected by gravity
    wcycle:integer;
  end;

  deco = record
    tp:integer;
    pos:integer; //0 - floor, 1 - ceiling, 2 - midair
    x,y,z:real;
    solid:boolean; //blocks passage
    size:integer;
    sizex,sizey:real;
  end;

  bonus = record
    alive:boolean;
    x,y:real;
    tp:integer; //0 - hp, 1 - ep
    comeback:integer;
  end;

  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCadencer1: TGLCadencer;
    CharMatLib: TGLMaterialLibrary;
    gmbase: TGLDummyCube;
    Camera: TGLCamera;
    GLSphere1: TGLSphere;
    GLLightSource1: TGLLightSource;
    ESpritesMatLib: TGLMaterialLibrary;
    BGMatLib: TGLMaterialLibrary;
    gmuibase2: TGLDummyCube;
    extrasphere: TGLSphere;
    gmuibase: TGLDummyCube;
    GLLightSource2_: TGLLightSource;
    gmmainmenu: TGLDummyCube;
    gmmainmenub: TGLDummyCube;
    MediaPlayer1: TMediaPlayer;
    Memo1: TMemo;
    fxmatlib: TGLMaterialLibrary;
    guimatlib: TGLMaterialLibrary;
    GLSMWaveOut1: TGLSMWaveOut;
    GLSoundLibrary1: TGLSoundLibrary;
    bottomtext: TGLHUDText;
    textdummy: TGLDummyCube;
    pointstext: TGLHUDText;
    Memo2: TMemo;
    GLWindowsBitmapFont1: TGLWindowsBitmapFont;
    procedure AddRL(txt:string);
    procedure HandleBottomText;
    procedure ClenupEffectsData;
    procedure ShowAtBottom(txt:string);
    procedure LoadSounds;
    procedure GetLevelOrder;
    procedure managewalking(walkdir:integer);
    procedure LoadConfig;
    procedure SaveConfig;
    procedure DoFullScreen(dofs:boolean);
    procedure GetComMan(comicid:integer);
    procedure ShowComic(comicid,pg:integer);
    procedure SwitchMusic(mname:string);
    procedure RunCurrentMusic;
    procedure LoadDecoParams(no,dectp,lset:integer);
    procedure DetermineLGENParams(lid:integer);
    procedure PushPlrAway(px,py:real; force:real);
    procedure ResetGame;
    procedure BuildMainMenu;
    procedure Cadencerrun;
    procedure Cadencerrun2;
    procedure handlemissiles;
    procedure datacleanup;
    procedure SpawnMissile(md,mx,my,mkx,mky,mspd,mspdy,mdmg,mboomd:real;g,b:boolean;mname:string);
    procedure processgui;
    procedure monitorblockvisibility;
    procedure ProcessEffects;
    procedure processenemysprites;
    procedure DropEffect(x,y,size:real; spr:string);
    procedure DamageArea(sender:integer;fxid:string;x,y,area:real; dmg:integer; splode:boolean; snd:string);
    procedure KillPlayer;
    procedure AssignPlayerSprite;
    procedure AssignPlayerAnim(lvl,st,ori:integer);
    procedure FillMLibraries;
    procedure GenLevel(lst:integer);
    procedure BuildLevelGeometry;
    procedure RecalcPositions;
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure LoadNextLevel;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer2Timer(Sender: TObject);
    procedure GLCadencer2Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure GLFullScreenViewer1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GLFullScreenViewer1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     //effects state and names

     //synchronization variable
     sticker,stick2:LongInt;


  end;

const g=9.8;  //gravity (for player only)
      bs=10;  //block width
      abg=1;  //backgrounds
      etps=9 ; //ebemy types
      bno=2;  //existing bonuses

var
  Form1: TForm1;
  Form:TForm;

  fxs:array[1..1000]of effect;
  sh:integer;
  eproc:boolean=false; //is the game processing effects now?
  cadencerhange:boolean=false; //is cadencer stopped because of effects handling?
  finalenemy:integer;
  level:array[0..1000]of levblock;
  startcube,endcube:TGLCube;
  ceil,floor,fltile:array[0..1000]of TGLCube;
  crushercyl:array[0..1000]of TGLCylinder;
  flplane,pitplanel,pitplaner:array[0..1000]of TGLPlane;
  bgtile,cltile:array[0..1000]of TGLSprite;
  ppl,ppr:array[0..1000]of boolean;
  bonsprites,esprites,decsprites:array[0..1000]of TGLSprite;
  missiles:array[0..1000]of TGLSprite;
  effects:array[0..1000]of tglsprite;
  plr:player;
  earr:array[0..1000]of enemy;
  // ! earr[100] is always a boss!
  darr:array[0..1000]of deco;
  barr:array[0..1000]of bonus;
  marr:array[0..1000]of missile;
  cbl:integer; //current block where player is
  xcol,ycol:integer; // if player has collision with x or y wall
  //plr:TGLSphere;
  gameexe:string;
  avbg:integer;
  lgen:boolean=true;
  //HUD
  hpsprite,engsprite,hpbg,engbg,xpsprite,lvlupsprite,xpbg,recsprite,recbg:TGLHUDSprite;
  tisprite,tibg,bosshpsprite,bosshpbg:TGLHUDSprite;
  gamemodeind,difficulty,exitb,settingsb:TGLHUDSprite;
  ab_1,ab_2,ab_3,ab_4,ab_5:TGLHUDSprite;
  biginput:TGLHUDSprite;
  redsplash:TGLHUDSprite;
  cmenuitem:integer; //0 - new game; 1 - difficulty; 2 - exit
  //bottomtext:TGLHUDText;

  //end HUD

  points:integer;
  shields,GLSprite1:TGLSprite;
  GLPlane1:TGLSprite;
  wannalevelup:boolean=true;
  lvllength:integer;
  levno,levelset:integer;
  timetot,timeleft:integer;
  abgen:integer; //number of available bg tiles for levelset
  gamelogo,spacebar:TGLHUDSprite;
  mmbg,mmhelpbg:TGLSprite;
  gamestate:integer; //0 - menu, 1 - game, 2 - credits
  rg:boolean=false;
  showbi:integer=0;//indicates if big banner is visible
  showrs:integer=0;//indicates if red damage glow is displayed
  bitex:string; //path to big banner's texture
  cp:integer;
  decsav:integer;
  tothpdam:integer;
  fscr:boolean=false;
  showhelp:Boolean=false;
  msdata:metascreen;
  dblleft:integer; //double keyleft countdown
  dblright:integer; //double keyleft countdown

  gamemode:integer; //indicates gamemode
  //0 - random infinite game; 1 - story mode
  hardcore:boolean=false;


  //story mode settings
  lorder:array[0..100]of integer; //levels in order
  ltot:integer; //number of levels


  //level generation parameters
  //loaded from levelmanifest.txt in THE SAME ORDER
  lg_minfh,lg_maxfh,lg_minch,lg_maxch:integer;
  lg_hasceil:boolean; //to show ceiling?
  lg_hascrushers:boolean; //to create crushers?
  lg_bgtl:integer; //background to load
  lg_floortype:integer; //floortype 0 - flat; 1 - random
  lg_music:string;
  lg_hasboss:boolean; //add boss enemy?
  lg_bosstype:integer; //what boss will it be?
  lg_floordepth:integer; //width of floor blocks; lg_floordepth=-1 means random
  lg_e:array[0..3]of integer; //4 possible enemies per level
  lg_forcedsmlevlength:integer; //level length in story mode

  twinsonlevel:integer; //indicates number of Twins on the leval;


  bonuscb:boolean=false;


  //available levelsets
  lsa:integer;

  //sound and music variables
  musicname:string;
  musicon:boolean=true;

  //comicview variables
  comicmode:boolean=false;
  autoturn:boolean;
  autoclose:boolean;
  initgs:integer;
  turntime:integer;
  turnstate:integer;
  pagesno:integer;
  currpg:integer;
  ccomicid:integer;

  //options
  workdist:integer;
  maxeffs:integer;
  maxmiss:integer;
  maxpoly:integer;

  lky:integer;

  ctextmsg:string;


implementation

{$R *.dfm}

uses USettings, UReport;

{procedure TForm1.SpawnEnemy(s_x,s_y:real;s_tp:integer;default:boolean);
var i:integer;
begin
  //spawns a specific enemy at specific point
  //if default = true, enemy is spawned BY DEFAULT


end;          }


procedure TForm1.AddRL(txt:string);
begin
  if form4.visible=true then Form4.Memo1.Lines.Add(txt);
end;

procedure TForm1.LoadConfig;
var fn:string;
begin
  fn:=gameexe+'\config.txt';
  Memo2.Lines.LoadFromFile(fn);
  workdist:=strtoint(Memo2.Lines[0]);
  maxmiss:=strtoint(Memo2.Lines[1]);
  maxpoly:=strtoint(Memo2.Lines[2]);
  maxeffs:=strtoint(Memo2.Lines[3]);
  musicon:=strtobool(Memo2.Lines[4]);
end;

procedure TForm1.SaveConfig;
var fn:string;
begin
  fn:=gameexe+'\config.txt';
  Memo2.Lines.Clear;
  Memo2.Lines.Add(inttostr(workdist));
  Memo2.Lines.Add(inttostr(maxmiss));
  Memo2.Lines.Add(inttostr(maxpoly));
  Memo2.Lines.Add(inttostr(maxeffs));
  Memo2.Lines.Add(booltostr(musicon));
  Memo2.Lines.SaveToFile(fn);
end;

procedure TForm1.SwitchMusic(mname:string);
begin
  with MediaPlayer1 do
  begin
    if FileExists(gameexe+'\Music\'+mname+'.mp3')=true then
      FileName:=gameexe+'\Music\'+mname+'.mp3';
    //ShowMessage(MediaPlayer1.FileName);
  end;
end;

procedure TForm1.RunCurrentMusic;
begin
  SwitchMusic(musicname);
  try MediaPlayer1.Close; except end;
  MediaPlayer1.Open;
  if musicon=true then
    MediaPlayer1.Play;
end;

function GetCBL(x:real):integer;
var i:integer;
begin
  i:=0;
  while ((i*bs)<x) do
  begin
    i:=i+1;
  end;
  result:=i-1;
end;

procedure TForm1.GetComMan(comicid:integer);
var i:integer;
    fn:string;
    done:boolean;
begin
  fn:=gameexe+'\Comics\'+inttostr(comicid)+'\comicmanifest.txt';
  Memo1.Lines.LoadFromFile(fn);
  pagesno:=strtoint(Memo1.Lines[0]);
  autoturn:=strtobool(Memo1.Lines[1]);
  turntime:=strtoint(Memo1.Lines[2]);
  autoclose:=strtobool(Memo1.Lines[3]);
end;

procedure TForm1.GetLevelOrder;
var i:integer;
    fn:string;
    done:boolean;
begin
  fn:=gameexe+'\levels\levelordermanifest.txt';
  Memo1.Lines.LoadFromFile(fn);
  ltot:=StrToInt(Memo1.Lines[0]);
  for i:=1 to ltot do
  begin
    lorder[i-1]:=strtoint(Memo1.Lines[i]);
  end;
end;

procedure Tform1.ShowComic(comicid,pg:integer);
var fn:string;
begin
  //displays the comic initial state and prepares the scene
  if comicmode=false then
  begin
    initgs:=gamestate;
    gamestate:=0;
    mmhelpbg.Visible:=true;
    mmbg.Visible:=False;
    mmbg.Visible:=false;
    mmhelpbg.Visible:=true;
    gamelogo.Visible:=false;
    gamemodeind.Visible:=false;
    exitb.Visible:=false;
    //settingsb.Visible
    difficulty.Visible:=False;
  end;
  comicmode:=true;
  fn:=gameexe+'\Comics\'+inttostr(comicid)+'\'+inttostr(pg)+'.png';
  with mmhelpbg.Material do
  begin
    BlendingMode:= bmTransparency;
    Texture.Image.LoadFromFile(fn);
    Texture.Disabled:= false;
    Texture.TextureMode:=tmDecal;
    FrontProperties.Emission.Red:=1;
    FrontProperties.Emission.Green:=1;
    FrontProperties.Emission.Blue:=1;
    FrontProperties.Diffuse.Alpha:=1;
  end;
  turnstate:=turntime;
  currpg:=pg;
  ccomicid:=comicid;
  //ShowMessage('pagesno='+inttostr(pagesno)+'; currpage='+inttostr(currpg)+'; autocloe='+BoolToStr(autoclose));
end;

function GetLSA:integer;
var i:integer;
    fn:string;
    done:boolean;
begin

  done:=false;
  i:=0;
  repeat
    fn:=gameexe+'\Textures\'+inttostr(i)+'\levelmanifest.txt';
    if FileExists(fn)=true then
    begin
      i:=i+1;
    end
    else
    begin
      done:=true;
    end;
  until (done=true);
  result:=i;
  //ShowMessage('LSA available: '+inttostr(i));
end;

procedure TForm1.LoadDecoParams(no,dectp,lset:integer);
var fn:string;
begin
  fn:=gameexe+'\Textures\'+inttostr(lset)+'\deco_'+inttostr(dectp)+'_desc.txt';
  Memo1.Lines.LoadFromFile(fn);
  with darr[no] do
  begin
    sizex:=strtofloat(Memo1.Lines[0]);
    sizey:=strtofloat(Memo1.Lines[1]);
    pos:=strtoint(Memo1.Lines[2]);
    x:=no*bs+bs/2;
    if pos=0 then
      y:=level[GetCBL(x)].fh;
    if pos=1 then
      y:=level[GetCBL(x)].ch;
    if (pos=2) and (lg_hasceil=true) then
      y:=level[GetCBL(x)].fh+random(round(level[GetCBL(x)].ch-level[GetCBL(x)].fh));
    if (pos=2) and (lg_hasceil=false) then
      y:=level[GetCBL(x)].fh+random(bs*2);
    z:=strtofloat(Memo1.Lines[3]);
    solid:=StrToBool(Memo1.Lines[4]);
  end;
end;

procedure TForm1.DetermineLGENParams(lid:integer);
var fn:string;
    i:integer;
begin
  fn:=gameexe+'\Textures\'+inttostr(lid)+'\levelmanifest.txt';
  Memo1.Lines.LoadFromFile(fn);
  {minfh,maxfh,minch,maxfh:integer;
  hasceil:boolean;
  hascrushers:boolean;
  bgtl:integer;  }
  i:=0;
  lg_minfh:=strtoint(Memo1.Lines[i]);
  i:=i+1;
  lg_maxfh:=strtoint(Memo1.Lines[i]);
  i:=i+1;
  lg_minch:=strtoint(Memo1.Lines[i]);
  i:=i+1;
  lg_maxch:=strtoint(Memo1.Lines[i]);
  i:=i+1;
  lg_hasceil:=StrToBool(Memo1.Lines[i]);
  i:=i+1;
  lg_hascrushers:=StrToBool(Memo1.Lines[i]);
  i:=i+1;
  lg_bgtl:=strtoint(Memo1.Lines[i]);
  i:=i+1;
  lg_floortype:=strtoint(Memo1.Lines[i]);
  i:=i+1;
  lg_music:=Memo1.Lines[i];
  i:=i+1;
  lg_hasboss:=StrToBool(Memo1.Lines[i]);
  i:=i+1;
  lg_bosstype:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
  lg_floordepth:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
  lg_e[0]:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
  lg_e[1]:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
  lg_e[2]:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
  lg_e[3]:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
  lg_forcedsmlevlength:=StrToInt(Memo1.Lines[i]);
  i:=i+1;
end;

function GetLSDecosNo(blset:integer):integer;
var i,n:integer;
    fn:string;
begin
  i:=-1;
  n:=0;
  repeat
    i:=i+1;
    fn:=gameexe+'\Textures\'+inttostr(blset)+'\deco_'+inttostr(i)+'.tga';
    if FileExists(fn)=true then n:=n+1;
  until (fileexists(fn)=false);
  result:=n;
end;

function GetBGNo(blockset:integer):integer;
var i,n:integer;
    fn:string;
begin
  i:=-1;
  n:=0;
  repeat
    i:=i+1;
    fn:=gameexe+'\Textures\'+inttostr(blockset)+'\bg_'+inttostr(i)+'.tga';
    if FileExists(fn)=true then n:=n+1;
  until (fileexists(fn)=false);
  result:=n;
end;



procedure TForm1.datacleanup;
var i:integer;
begin
  For i:=0 to 100 do
  begin
    earr[i].alive:=false;
    try FreeAndNil(esprites[i]); except end;
    try FreeAndNil(missiles[i]); except end;
  end;
  for i:=0 to 1000 do
  begin
    marr[i].alive:=false;
    fxs[i].aframe:=0;
    fxs[i].spriten:='';
    try FreeAndNil(effects[i]); except end;
  end;
end;

procedure SwitchLevel(lst:integer);
begin
  plr.wkdir:=-1;
  Form1.GenLevel(lst);
  Form1.BuildLevelGeometry;
  musicname:=lg_music;
  Form1.RunCurrentMusic;
end;

procedure TForm1.GenLevel(lst:integer);
var i,ech:integer;
    bonno,bpb:integer;
    eno:real;
    enemiesok:boolean;
begin
  Lgen:=true;
  lsa:=GetLSA;
  cp:=0;
  if gamemode=0 then
    if lg_hasboss=true then
    begin
      lvllength:=20;
      bonuscb:=true;
    end
    else
    begin
      bonuscb:=false;
    end;

  //if levno=1 then levelset:=1
  //else
  if (lst=-1) or (lst>lsa) then
    levelset:=Random(lsa)
  else
    levelset:=lst;
  DetermineLGENParams(levelset);
  if gamemode=1 then
  begin
    lvllength:=lg_forcedsmlevlength;
    ShowAtBottom('LEVEL LENGTH: '+inttostr(lg_forcedsmlevlength));
    if lg_hasboss=true then bonuscb:=true else bonuscb:=false;
  end;
  abgen:=GetBGNo(levelset);
  decsav:=GetLSDecosNo(levelset);
  //generates a level
  //ShowMessage('Generating a level...');
  for i:=0 to 1000 do
  begin
    marr[i].alive:=false;
  end;
  //defining total time to get through level
  if lg_hasboss=false then
    timetot:=lvllength*2*10
  else
    timetot:=lvllength*2*10*3;
  //setting time to max
  timeleft:=timetot;

  //defining blocks of level
  for i:=0 to lvllength do
  begin
    with level[i] do
    begin

      crusher:=false;
      pit:=false;
      //defining block width
      x1:=i*bs;
      x2:=i*bs+bs;
      //setting floor height
      if lg_floortype=1 then
      begin
        if plr.plevel>2 then
          fh:=0-Random(round(bs));
        if plr.plevel<=2 then
          fh:=0-Random(round(bs/4));
      end;
      if lg_floortype=0 then
      begin
        fh:=-round(bs/4);
      end;
      //setting floor height in case of outta boundaries
      if (lg_minfh>fh) then
      begin
        fh:=lg_minfh;
      end;
      if (lg_maxfh<fh) then
      begin
        fh:=lg_maxfh;
      end;

      //setting block depth
      if lg_floordepth=-1 then
         w:=Random(bs)+bs/2
      else
        w:=lg_floordepth;
      {case levelset of
      1:begin
          w:=bs;
        end;
      else
        begin
          w:=Random(bs)+bs/2;
        end;
      end;  }


      //creating pits
      if (random(100)<(plr.plevel*5)) and (i<>0) then
      begin
        if (plr.plevel>2) or (level[i-1].pit=false) then
        begin
          fh:=((-1)*bs*3);
          pit:=true;
        end;
      end;
      if (pit=true) and (lg_hasboss=true) and (lg_bosstype=8) and (i>lvllength-8) then
      begin
        fh:=lg_minfh;
        pit:=false;
      end;
      {if (level[i-1].pit=true) and (plr.level<=2) then
      begin
        if levno>1 then
        begin
          fh:=level[i-2].fh-Random(round(bs/5));
          pit:=false;
        end
        else
        begin
          fh:=-round(bs/4);
          pit:=false;
        end;
      end;}

      //CREATING CEILINGS
      if lg_hasceil=true then
      begin
        if (i=0) then
          ch:=fh+round(bs*2)+Random(round(bs*2))
        else
          ch:=level[i-1].ch+random(bs)-Random(bs);
        if abs(ch-fh)<(GLSphere1.Radius*3+0.01) then
          ch:= level[i-1].ch+bs;
        if ch>bs*5 then
        begin
          ch:= level[i-1].ch-bs;
        end;

        //switching ch in case it's outta boundaries
        if (lg_maxch<ch) then
        begin
          ch:=lg_maxch;
        end;
        if (lg_minch>ch) then
        begin
          ch:=lg_minch;
        end;
        //forcing final boss ceiling height
        if (lg_bosstype=8) and (i>(lvllength-3)) then
        begin
          level[lvllength].ch:=level[lvllength].fh+35;
          level[lvllength-1].ch:=level[lvllength-1].fh+35;
          level[lvllength-2].ch:=level[lvllength-2].fh+35;
          level[lvllength-3].ch:=level[lvllength-3].fh+32;
          level[lvllength-4].ch:=level[lvllength-4].fh+30;
          level[lvllength-4].ch:=level[lvllength-5].fh+28;
          level[lvllength-4].ch:=level[lvllength-6].fh+25;
          level[lvllength-4].ch:=level[lvllength-7].fh+23;
          level[lvllength-4].ch:=level[lvllength-7].fh+20;
        end;
        //defining basic ceiling height (for crushers)
        bch:=ch;

      end
      else
      begin
        ch:=lg_maxch;
      end;

      //creating crushers
      if lg_hascrushers=true then
      begin
        if (random(100)<(plr.plevel*3)) and (i>4) and (i<(lvllength-4)) and (pit=false) and (levno>1) and
        (abs(ch-fh)>(1.5*bs))  then
        begin
          spd:=(bs/2+random(bs))/(bs*(200)/sqrt(plr.plevel));
          crusher:=true;
        end;
      end;


    end;
  end;

  //ENEMIES and BONUSES
  twinsonlevel:=0;
  earr[100].alive:=false;

  for i:=0 to 100 do
  begin
    //cleaning bonuses
    barr[i].alive:=false;
    barr[i].tp:=-1;

    //creating enemies
      if ((i<lvllength) or ((i=100) and (lg_hasboss=true))) then
      with earr[i] do
      begin
        alive:=false;
        if ((level[i].crusher=false) and (level[i].pit=false) and
           (random(100)<sqr(plr.plevel*10)) and (level[i].x1>bs*10)) or
           ((i=100) and (lg_hasboss=true)) then
        begin
          //repeat
            alive:=true;
            finalenemy:=i;
            ech:=Random(4);
            if lg_e[ech]=2 then
            begin
              if Random(100)>(80+plr.plevel) then ech:=Random(4);
            end;
            //making sure that boss WILL NOT spawn at random
            if (lg_e[ech]=6) and (i<>100) then
            begin
              repeat
                ech:=Random(4);
              until (lg_e[ech]<>6);
            end;
            if (lg_e[ech]=7) and (twinsonlevel>5) then
            begin
              repeat
                ech:=Random(4);
              until ((lg_e[ech]<>8) and (lg_e[ech]<>6));
            end;
            if (i=100) and (lg_hasboss=true) then
            begin
              tp:=lg_bosstype;
              //ShowMessage('Creating Boss!');
            end;
            if i<>100 then
              tp:=lg_e[ech];
            case tp of
            0:begin
                //static floating drone that damages area
                size:=GLSphere1.Radius*2;
                pattern:=0;
                earr[i].y:=level[i].fh+random(abs(round(level[i].ch-level[i].fh-size/2)))+round(size/2);
                earr[i].x:=i*bs+random(bs);
                atype:=4;
                attack:=10;
                earr[i].state:=0;
                xpval:=10;
                hp:=5;
                hpmax:=5;
                rectime:=200;
                ac:=1000;
                deatheffect:='boom2';
              end;
            1:begin
                size:=GLSphere1.Radius*3;
                pattern:=0;
                earr[i].y:=level[i].fh+size/2;
                earr[i].x:=i*bs+1+random(bs-1);
                atype:=3;
                attack:=10;
                earr[i].state:=0;
                xpval:=20;
                hp:=11;
                hpmax:=11;
                rectime:=200;
                ac:=50;
               deatheffect:='nil';
              end;
            2:begin
                size:=GLSphere1.Radius;
                pattern:=0;
                earr[i].y:=level[i].fh+random(abs(round(level[i].ch-level[i].fh-size/2)))+round(size/2);
                earr[i].x:=i*bs+1+random(bs-1);
                atype:=3;
                attack:=30;
                earr[i].state:=0;
                xpval:=0;
                hp:=1;
                hpmax:=1;
                alive:=false;
                ac:=0;
                deatheffect:='nil';
              end;
            3:begin
                size:=GLSphere1.Radius*3.3;
                pattern:=0;
                earr[i].y:=level[i].fh+size/2;
                earr[i].x:=i*bs+1+random(bs-1);
                atype:=3;
                attack:=50;
                earr[i].state:=0;
                xpval:=30;
                hp:=30;
                hpmax:=30;
                rectime:=500;
                ac:=10;
                deatheffect:='nil';
              end;
            4:begin
                size:=GLSphere1.Radius*2.7;
                pattern:=1;
                earr[i].x:=i*bs+1+random(bs-1);
                y1:=level[i].fh+size/2;
                y2:=level[i].ch-size/2;
                earr[i].y:=y1+round(y2-y1);
                atype:=3;
                attack:=5;
                earr[i].state:=0;
                xpval:=30;
                hp:=15;
                hpmax:=15;
                ky:=0.0001;
                rectime:=100;
                ac:=200;
                deatheffect:='nil';
              end;
            5:begin
                size:=GLSphere1.Radius*2.1;
                pattern:=1;
                earr[i].x:=i*bs+1+random(bs-1);
                earr[i].y:=level[i].fh+size/2;
                //earr[i].y:=y1+round(y2-y1);
                atype:=3;
                attack:=50;
                earr[i].state:=0;
                xpval:=30;
                hp:=5;
                hpmax:=15;
                ky:=0.0001;
                rectime:=100;
                ac:=200;
                deatheffect:='slime';
              end;
            6:begin
                size:=GLSphere1.Radius*10;
                pattern:=1;
                earr[i].x:=bs*2;
                earr[i].y:=bs*10;
                //earr[i].y:=y1+round(y2-y1);
                atype:=3;
                attack:=50;
                earr[i].state:=0;
                xpval:=300;
                hp:=200+50*plr.plevel;
                hpmax:=200+50*plr.plevel;
                ky:=0.0001;
                rectime:=100;
                ac:=50;
                deatheffect:='boom2';
              end;
              7:begin
                size:=GLSphere1.Radius*2.4;
                pattern:=1;
                earr[i].y:=level[i].fh+size/2;
                earr[i].x:=i*bs+1+random(bs-1);
                //earr[i].y:=y1+round(y2-y1);
                atype:=3;
                attack:=10+10*plr.lvl;
                earr[i].state:=0;
                xpval:=40+10*plr.lvl;
                hp:=30+5*PLR.lvl;
                hpmax:=200+50*plr.lvl;
                ky:=0.0001;
                rectime:=4000;
                ac:=50;
                deatheffect:='nil';
                twinsonlevel:=twinsonlevel+1;
              end;
            8:begin
                pattern:=1;
                earr[i].x:=lvllength*bs+bs/2;
                earr[i].y:=(level[getcbl(round(earr[i].x))].fh+((level[getcbl(round(earr[i].x))].ch-level[getcbl(round(earr[i].x))].fh)/2));
                size:=(level[getcbl(earr[i].x)].ch-level[getcbl(earr[i].x)].fh);
                //earr[i].y:=y1+round(y2-y1);
                atype:=3;
                attack:=90;
                earr[i].state:=0;
                xpval:=10000;
                hp:=1000+50*plr.plevel;
                hpmax:=1000+50*plr.plevel;
                ky:=0.0001;
                rectime:=100;
                ac:=50;
                deatheffect:='boom2';
              end;
            end;
          //if twinsonlevel<=5 then enemiesok:=true else enemiesok:=false;
          //until (enemiesok=true);
        end;
      end;
  end;



  //defining number of bonuses
  if lg_hasboss=false then
    bonno:=round(lvllength/(plr.lvl*3))
  else
    bonno:=10;
  eno:=(bs*lvllength)/bonno;
  for i:=0 to (bonno-1) do
    with barr[i] do
    begin
      alive:=true;
      x:=eno+eno*i;
      bpb:=GetCBL(x);
      if lg_hasceil=false then
        y:=random(round(level[bpb].ch-GLSphere1.Radius-level[bpb].fh))+level[bpb].fh+GLSphere1.Radius
      else
        y:=level[bpb].fh+bs;
      tp:=random(bno);
    end;

  //DECORATIONS
  for i:=0 to 1000 do
  begin
    darr[i].tp:=-1;
    darr[i].solid:=false;
  end;

  if decsav>0 then
  begin
    //ShowMessage('decsav='+inttostr(decsav));
    for i:=0 to lvllength do
    begin
      darr[i].tp:=-1;
      if random(100)<20 then
      begin
        darr[i].tp:=Random(decsav);
        LoadDecoParams(i,darr[i].tp,levelset);

      end;
      //eno:=Random(decsav);
      
    end;
  end
  else
  begin
    for i:=0 to 100 do darr[i].tp:=-1;
  end;


  //ShowMessage('Level Generation complete...');
end;




procedure TForm1.FillMLibraries;
var i,j,k,l,ll:integer;
    fn,fl,mn:string;
    fr:integer;
    done,dd:boolean;
begin
  //fills MatLibs with materials
  //Loading Player Sprites
  {
  for i:=0 to 5 do //levels
  for j:=0 to 5 do //states
  for k:=1 to 2 do //orientations
  begin
    with charmatlib.Materials.Add do
    begin
      Material.Texture.Image.LoadFromFile(gameexe+'\Sprites\p_s_'+inttostr(i)+'_'+inttostr(j)+'_'+inttostr(k)+'.png');
      Material.Texture.Disabled:=false;
      Material.Texture.ImageClassName := 'TGLCompositeImage';
      //Material.Texture.ImageAlpha:=;
      Material.BlendingMode:= bmTransparency;
      Name:='ps_'+inttostr(i)+'_'+inttostr(j)+'_'+inttostr(k);
    end;
  end;   }
  l:=0;
  CharMatLib.Materials.Clear;
  fxmatlib.Materials.Clear;
  ESpritesMatLib.Materials.Clear;
  guimatlib.Materials.Clear;
  BGMatLib.Materials.Clear;
  for l:=1 to 5 do
  for i:=0 to 10 do
  begin
    done:=false;
    k:=0;
    repeat
      j:=2;
      //defining animatin to load
      case k of
      0:begin
          fl:='s';
        end;
      1:begin
          fl:='j';
        end;
      2:begin
          fl:='w';
        end;
      3:begin
          fl:='h';
        end;
      4:begin
          fl:='m';
        end;
      end;
      k:=k+1;
      if k=5 then done:=true;
      //defining animation frame name
      fn:=gameexe+'\Sprites\'+inttostr(l)+'\'+fl+'_'+inttostr(j)+'_'+inttostr(i)+'.tga';
      mn:=inttostr(l)+'_'+fl+'_'+inttostr(j)+'_'+inttostr(i);
      if fl='j' then
      begin
        if i=0 then
        begin
          fn:=gameexe+'\Sprites\'+inttostr(l)+'\'+fl+'_'+inttostr(j)+'_0.tga';
          mn:=inttostr(l)+'_'+fl+'_'+inttostr(j)+'_0';
        end;
        if i>0 then
        begin
          j:=1;
          fn:=gameexe+'\Sprites\'+inttostr(l)+'\'+fl+'_'+inttostr(j)+'_0.tga';
          mn:=inttostr(l)+'_'+fl+'_'+inttostr(j)+'_0';
        end;
      end;
      if fl='h' then
      begin
        fn:=gameexe+'\Sprites\'+inttostr(l)+'\'+fl+'_'+inttostr(j)+'_0.tga';
        mn:=inttostr(l)+'_'+fl+'_'+inttostr(j)+'_0';
      end;
      //adding material to matlib
      dd:=false;
      if (fl='j') and (dd=false) and (i>1) then dd:=true;
      if (fl='h') and (dd=false) and (i>0) then dd:=true;
      if (fl<>'o') and (i=10) then dd:=true;
      if dd=false then
      with charmatlib.Materials.Add do
      begin
        Material.Texture.Image.LoadFromFile(fn);
        Material.Texture.Disabled:= false;
        Material.BlendingMode:= bmTransparency;
        Material.Texture.TextureMode:=tmModulate;
        Material.FrontProperties.Emission.Red:=1;
        Material.FrontProperties.Emission.Green:=1;
        Material.FrontProperties.Emission.Blue:=1;
        Material.FrontProperties.Emission.Alpha:=1;
        Name:=mn;
      end;
    until done=true;
  end;


  //filling effects matlib
  Memo1.Lines.LoadFromFile(gameexe+'\esprites\fxmanifest.txt');
  for i:=0 to (Memo1.Lines.Count-1) do
  begin
    fl:=Memo1.Lines[i];
    k:=0;
    repeat
      fn:=gameexe+'\esprites\'+fl+'_'+inttostr(k)+'.tga';
      if fileexists(fn)=true then begin end else
      begin
        fn:=gameexe+'\esprites\empty.tga';
      end;
      mn:=fl+'_'+inttostr(k);
      with fxmatlib.Materials.Add do
      begin
        Material.Texture.Image.LoadFromFile(fn);
        Material.Texture.Disabled:= false;
        Material.BlendingMode:= bmTransparency;
        Material.Texture.TextureMode:=tmModulate;
        Material.FrontProperties.Emission.Red:=1;
        Material.FrontProperties.Emission.Green:=1;
        Material.FrontProperties.Emission.Blue:=1;
        Material.FrontProperties.Diffuse.Alpha:=1;
        Name:=mn;
      end;
      k:=k+1;
    until k=10;

  end;

  Memo1.Lines.LoadFromFile(gameexe+'\esprites\bullmanifest.txt');
  for i:=0 to (Memo1.Lines.Count-1) do
  begin
    fl:=Memo1.Lines[i];
    k:=0;
    fn:=gameexe+'\esprites\bull_'+fl+'.tga';
    if fileexists(fn)=true then begin end else
    begin
      fn:=gameexe+'\esprites\empty.tga';
    end;
    mn:='bull_'+fl;
    with fxmatlib.Materials.Add do
    begin
      Material.Texture.Image.LoadFromFile(fn);
      Material.Texture.Disabled:= false;
      Material.BlendingMode:= bmTransparency;
      Material.Texture.TextureMode:=tmModulate;
      Material.FrontProperties.Emission.Red:=1;
      Material.FrontProperties.Emission.Green:=1;
      Material.FrontProperties.Emission.Blue:=1;
      Material.FrontProperties.Diffuse.Alpha:=1;
      Name:=mn;
    end;
  end;

  //loading enemy sprites

  for i:=0 to (etps-1) do
  begin
    for k:=0 to 10 do
    begin
      mn:='e'+inttostr(i)+'_'+inttostr(k);
      fn:=gameexe+'\esprites\e'+inttostr(i)+'_'+inttostr(k)+'.tga';
      if fileexists(fn)=true then
      with ESpritesMatLib.Materials.Add do
      begin
        Material.Texture.Image.LoadFromFile(fn);
        Material.Texture.Disabled:= false;
        Material.BlendingMode:= bmTransparency;
        Material.Texture.TextureMode:=tmModulate;
        Material.FrontProperties.Emission.Red:=1;
        Material.FrontProperties.Emission.Green:=1;
        Material.FrontProperties.Emission.Blue:=1;
        Material.FrontProperties.Diffuse.Alpha:=1;
        Name:=mn;
      end;
    end;
  end;

  //filling GUI matlib
  fl:=Memo1.Lines[i];
  k:=1;
  repeat
    for i:=0 to 1 do
    begin
      if i=1 then
      begin
        fn:=gameexe+'\sprites\ab_'+inttostr(k)+'_a.tga';
        mn:='ab_'+inttostr(k)+'_a';

      end;
      if i=0 then
      begin
        fn:=gameexe+'\sprites\ab_'+inttostr(k)+'_na.tga';
        mn:='ab_'+inttostr(k)+'_na';

      end;
      with guimatlib.Materials.Add do
      begin
        Material.Texture.Image.LoadFromFile(fn);
        Material.Texture.Disabled:= false;
        Material.BlendingMode:= bmTransparency;
        Material.Texture.TextureMode:=tmModulate;
        Material.FrontProperties.Emission.Red:=1;
        Material.FrontProperties.Emission.Green:=1;
        Material.FrontProperties.Emission.Blue:=1;
        Material.FrontProperties.Diffuse.Red:=1;
        Material.FrontProperties.Diffuse.Green:=1;
        Material.FrontProperties.Diffuse.Blue:=1;
        Material.FrontProperties.Diffuse.Alpha:=1;
        Name:=mn;
        //ShowMessage(mn);
      end;
    end;
    k:=k+1;
  until k=6;


  i:=0;
  BGMatLib.Materials.Clear;
  while fileexists(gameexe+'\bg\'+inttostr(i)+'.png')=true do
  begin
    with BGMatLib.Materials.Add do
    begin
      Material.Texture.ImageClassName := 'TGLCompositeImage';
      Material.Texture.Image.LoadFromFile(gameexe+'\bg\'+inttostr(i)+'.png');
      Material.Texture.Disabled:=false;
      //Material.Texture.ImageAlpha:=;
      Material.BlendingMode:= bmTransparency;
      Name:='bg_'+inttostr(i);
    end;
    i:=i+1;
  end;
  avbg:=i;

end;

procedure TForm1.LoadSounds;
var i,k:integer;
    fn,mn,fl:string;
begin
  //filling soundlib
  Memo1.Lines.LoadFromFile(gameexe+'\sound\soundmanifest.txt');
  for i:=0 to (Memo1.Lines.Count-1) do
  begin
    fl:=Memo1.Lines[i];
    k:=0;
    repeat
      fn:=gameexe+'\sound\'+fl+'.wav';
      if fileexists(fn)=true then
      begin
        mn:=fl;
        GLSoundLibrary1.Samples.AddFile(fn);
      end;
      k:=k+1;
    until k=10;

  end;
end;

procedure TForm1.AssignPlayerAnim(lvl,st,ori:integer);

begin
  //GLAnimatedSprite1.MaterialLibrary:=CharMatLib;
  //GLAnimatedSprite1.MaterialLibrary.LibMaterialByName.Assign('ps_'+inttostr(lvl)+'_'+inttostr(st)+'_'+inttostr(ori));

  //GLAnimatedSprite1.Animations.
end;

procedure TForm1.BuildLevelGeometry;
var i:integer;
    fn:string;
begin
  //creting/killing UI sprites
  AddRL('Building level geometry');
  try FreeAndNil(redsplash); except end;
  try FreeAndNil(startcube); except end;
  try FreeAndNil(endcube); except end;
  try FreeAndNil(GLPlane1); except end;
  try FreeAndNil(GLSprite1); except end;
  try FreeAndNil(shields); except end;
  try FreeAndNil(hpsprite); except end;
  try FreeAndNil(engsprite); except end;
  try FreeAndNil(tisprite); except end;
  try FreeAndNil(bosshpsprite); except end;
  try FreeAndNil(xpsprite); except end;
  try FreeAndNil(xpbg); except end;
  try FreeAndNil(hpbg); except end;
  try FreeAndNil(engbg); except end;
  try FreeAndNil(tibg); except end;
  try FreeAndNil(bosshpbg); except end;
  try FreeAndNil(lvlupsprite); except end;
  try FreeAndNil(recsprite); except end;
  try FreeAndNil(recbg); except end;
  try FreeAndNil(biginput); except end;
  try FreeAndNil(ab_1); except end;
  try FreeAndNil(ab_2); except end;
  try FreeAndNil(ab_3); except end;
  try FreeAndNil(ab_4); except end;
  try FreeAndNil(ab_5); except end;

  for i:=0 to 1000 do
  begin
    //preparing missiles
    try FreeAndNil(missiles[i]); except end;
    missiles[i]:=TGLSprite.CreateAsChild(gmbase);
    missiles[i].Material.MaterialLibrary:=fxmatlib;
    missiles[i].Visible:=false;
    with missiles[i] do
    begin
      //Slices:=round(maxpoly/2);
      //Stacks:=round(maxpoly/2);
      Width:=0.3;
      Height:=0.3;
      Visible:=false;
    end;
    //preparing effects
    try FreeAndNil(effects[i]); except end;
    //fxs[i].alive:=false;
    effects[i]:=TGLSprite.CreateAsChild(gmbase);
    effects[i].Material.MaterialLibrary:=fxmatlib;
    effects[i].Visible:=false;
  end;

  //ClenupEffectsData;
  //for i:=0 to 1000 do
  //begin
  //
  //
  //end;

  redsplash:=TGLHUDSprite(gmuibase2.AddNewChild(TGLHUDSprite));
  tibg:=TGLHUDSprite(gmuibase2.AddNewChild(TGLHUDSprite));
  engbg:=TGLHUDSprite(gmuibase2.AddNewChild(TGLHUDSprite));
  hpbg:=TGLHUDSprite(gmuibase2.AddNewChild(TGLHUDSprite));
  xpbg:=TGLHUDSprite(gmuibase2.AddNewChild(TGLHUDSprite));
  recbg:=TGLHUDSprite(gmuibase2.AddNewChild(TGLHUDSprite));
  engsprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  tisprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  bosshpbg:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  bosshpsprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  hpsprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  xpsprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  lvlupsprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  recsprite:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  biginput:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  ab_1:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  TGLHUDSprite(ab_1).Material.MaterialLibrary:=guimatlib;
  ab_2:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  TGLHUDSprite(ab_2).Material.MaterialLibrary:=guimatlib;
  ab_3:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  TGLHUDSprite(ab_3).Material.MaterialLibrary:=guimatlib;
  ab_4:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  TGLHUDSprite(ab_4).Material.MaterialLibrary:=guimatlib;
  ab_5:=TGLHUDSprite(gmuibase.AddNewChild(TGLHUDSprite));
  TGLHUDSprite(ab_5).Material.MaterialLibrary:=guimatlib;
  lvlupsprite.Visible:=false;
  GLSprite1:=TGLSprite(gmbase.AddNewChild(TGLSprite));
  TGLSprite(GLSprite1).Material.MaterialLibrary:=CharMatLib;
  startcube:=TGLCube(gmbase.AddNewChild(TGLCube));
  endcube:=TGLCube(gmbase.AddNewChild(TGLCube));
  shields:=TGLSprite(gmbase.AddNewChild(TGLSprite));
  GLSprite1.Height:=GLSphere1.Radius*2;
  GLSprite1.Width:=GLSprite1.Height;
  GLPlane1:=TGLSprite.CreateAsChild(gmbase);
  hpsprite.Height:=10;
  engsprite.Height:=10;
  xpsprite.Height:=10;
  hpbg.Height:=16;
  xpbg.Height:=16;
  engbg.Height:=16;

  //starting and ending cubes
    startcube.CubeHeight:=abs(level[0].ch-level[0].fh)*3;
    startcube.CubeWidth:=(bs*5);
    startcube.CubeDepth:=bs;
    startcube.position.y:=level[0].fh+abs(level[0].ch-level[0].fh)/2;
    startcube.position.x:=0-startcube.CubeWidth/2;
    if lg_hasceil=true then
      startcube.Visible:=true
    else
     startcube.Visible:=false;
    fn:=gameexe+'\textures\'+inttostr(levelset)+'\1.tga';
    with startcube.Material do
    begin
      BlendingMode:= bmOpaque;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;

    endcube.CubeHeight:=abs(level[lvllength-1].ch-level[lvllength-1].fh)*3;
    endcube.CubeWidth:=(bs*5);
    endcube.CubeDepth:=bs;
    endcube.position.y:=level[lvllength-1].fh+abs(level[lvllength-1].ch-level[lvllength-1].fh)/2;
    endcube.position.x:=(lvllength+1)*(bs)+endcube.CubeWidth/2;
    if lg_hasceil=true then
      endcube.Visible:=true
    else
     endcube.Visible:=false;
    fn:=gameexe+'\textures\'+inttostr(levelset)+'\1.tga';
    with endcube.Material do
    begin
      BlendingMode:= bmOpaque;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;

  //done starting and ending cubes

  fn:=gameexe+'\Sprites\shield.tga';
  shields.Width:=GLSphere1.Radius*2;
  shields.Height:=GLSphere1.Radius*2;
  with shields.Material do
  begin
    BlendingMode:= bmTransparency;
    Texture.Image.LoadFromFile(fn);
    Texture.Disabled:= false;
    Texture.TextureMode:=tmModulate;
    FrontProperties.Emission.Red:=1;
    FrontProperties.Emission.Green:=1;
    FrontProperties.Emission.Blue:=1;
    FrontProperties.Diffuse.Alpha:=1;
  end;
  with redsplash do
  begin
    fn:=gameexe+'\textures\redsplash.tga';
    with redsplash.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=0;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;
  with hpsprite do
  begin
    fn:=gameexe+'\sprites\hp.tga';
    with hpsprite.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;

  with bosshpsprite do
  begin
    fn:=gameexe+'\sprites\hp.tga';
    with bosshpsprite.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;

  with tisprite do
  begin
    fn:=gameexe+'\sprites\timeind.tga';
    with tisprite.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;

  with lvlupsprite do
  begin
    fn:=gameexe+'\sprites\lup_pan.tga';
    with lvlupsprite.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      //FrontProperties.Diffuse.Red:=1;
      //FrontProperties.Diffuse.Green:=1;
      //FrontProperties.Diffuse.Blue:=1;
      //FrontProperties.Diffuse.Alpha:=1;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;

  with xpsprite do
  begin
    fn:=gameexe+'\sprites\xp.tga';
    with xpsprite.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;

  with recsprite do
  begin
    fn:=gameexe+'\sprites\rec.tga';
    with recsprite.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //hpsprite.Height:=1;
    Visible:=true;
  end;

  with engsprite do
  begin
    //VisibilityCulling:=;
    fn:=gameexe+'\sprites\eng.tga';
    with engsprite.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //engsprite.Height:=1;
    Visible:=true;
  end;

  with hpbg do
  begin
    fn:=gameexe+'\sprites\pointerbg.tga';
    with hpbg.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    hpsprite.Height:=16;
    Visible:=true;
  end;


  with bosshpbg do
  begin
    fn:=gameexe+'\sprites\pointerbg.tga';
    with bosshpbg.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    hpsprite.Height:=16;
    Visible:=true;
  end;

  with tibg do
  begin
    fn:=gameexe+'\sprites\timeindbg.tga';
    with tibg.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Visible:=true;
  end;

  with recbg do
  begin
    fn:=gameexe+'\sprites\pointerbg.tga';
    with recbg.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    hpsprite.Height:=16;
    Visible:=true;
  end;

  with xpbg do
  begin
    fn:=gameexe+'\sprites\pointerbg.tga';
    with xpbg.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    xpbg.Height:=16;
    Visible:=true;
  end;

  with engbg do
  begin
    fn:=gameexe+'\sprites\pointerbg.tga';
    with engbg.Material do
    begin
      //BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    hpbg.Height:=16;
    Visible:=true;
  end;


  //creates all objects for a level
  //ShowMessage('Building level geometry...');

  bitex:=gameexe+'\textures\'+inttostr(levelset)+'\title.tga';
  showbi:=30;

  sh:=Form1.ClientHeight;
  for i:=0 to lvllength do
  begin
    //if i=100 then ShowMessage('Freeandnil...');
    try
      FreeAndNil(ceil[i]);
      FreeAndNil(floor[i]);
      FreeAndNil(flplane[i]);
      FreeAndNil(bgtile[i]);
      FreeAndNil(fltile[i]);
      FreeAndNil(cltile[i]);
      FreeAndNil(crushercyl[i]);
      FreeAndNil(pitplanel[i]);
      FreeAndNil(pitplaner[i]);
      FreeAndNil(decsprites[i]);
      //FreeAndNil(esprites[i]);
      //FreeAndNil();
    finally
    end;
    //if i=100 then ShowMessage('Adding ceiling...');
    ceil[i]:=TGLCube.CreateAsChild(gmbase);
    ceil[i].CubeHeight:=(bs);
    ceil[i].CubeWidth:=(bs);
    if lg_floordepth=-1 then
      ceil[i].CubeDepth:=round(bs/5)+random(round(bs))
    else
      ceil[i].CubeDepth:=lg_floordepth;
    ceil[i].position.y:=level[i].ch+(ceil[i].CubeHeight/2);
    ceil[i].position.x:=level[i].x1+round(bs/2);
    if lg_hasceil=true then
      ceil[i].Visible:=true
    else
      ceil[i].Visible:=false;
    fn:=gameexe+'\textures\'+inttostr(levelset)+'\2.tga';
    with ceil[i].Material do
    begin
      BlendingMode:= bmOpaque;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;

    if level[i].crusher=true then
    begin
      crushercyl[i]:=TGLCylinder.CreateAsChild(gmbase);
      crushercyl[i].Height:=(bs*4);
      crushercyl[i].TopRadius:=(bs/7);
      crushercyl[i].BottomRadius:=(bs/7);
      crushercyl[i].position.y:=level[i].ch+bs*3;
      crushercyl[i].position.x:=level[i].x1+round(bs/2);
      crushercyl[i].Visible:=true;
      fn:=gameexe+'\textures\'+inttostr(levelset)+'\punchshine.tga';
      with crushercyl[i].Material do
      begin
        BlendingMode:= bmOpaque;
        Texture.Image.LoadFromFile(fn);
        Texture.Disabled:= false;
        Texture.TextureMode:=tmModulate;
        FrontProperties.Diffuse.Red:=1;
        FrontProperties.Diffuse.Green:=1;
        FrontProperties.Diffuse.Blue:=1;
        FrontProperties.Diffuse.Alpha:=1;
      end;
    end;

    //if i=100 then ShowMessage('Add floor...');
    floor[i]:=TGLCube.CreateAsChild(gmbase);
    floor[i].CubeHeight:=(bs);
    floor[i].position.y:=level[i].fh-(floor[i].CubeHeight/2);
    floor[i].CubeWidth:=(bs);
    floor[i].CubeDepth:=level[i].w;
    floor[i].position.x:=level[i].x1+round(bs/2);;
    floor[i].Visible:=true;
    if level[i].crusher=false then
      fn:=gameexe+'\textures\'+inttostr(levelset)+'\1.tga'
    else
      fn:=gameexe+'\textures\'+inttostr(levelset)+'\crusher.tga';
    with floor[i].Material do
    begin
      BlendingMode:= bmOpaque;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    ppr[i]:=false;
    ppr[i]:=false;
    if level[i].pit=true then
    begin
      if (i<lvllength) and (i>0) then
      begin
        if level[i-1].pit=false then
        begin
          ppl[i]:=true;
          //ShowMessage('Making pit plane');
          pitplanel[i]:=TGLPlane.CreateAsChild(gmbase);
          pitplanel[i].Width:=abs(level[i-1].fh-level[i].fh-bs);//  (bs*2);
          if i<>0 then
            pitplanel[i].Height:=(level[i-1].w);
          pitplanel[i].position.y:=level[i].fh+pitplanel[i].Width/2;
          pitplanel[i].position.x:=floor[i].position.X-bs/2-0.01;
          pitplanel[i].Position.Z:=floor[i].Position.Z;
          pitplanel[i].Visible:=true;
          pitplanel[i].RollAngle:=90;
          pitplanel[i].PitchAngle:=-90;
          fn:=gameexe+'\textures\'+inttostr(levelset)+'\1_bot.tga';
          if fileexists(fn)=false then fn:=gameexe+'\textures\'+inttostr(levelset)+'\1.tga';
          with pitplanel[i].Material do
          begin
            BlendingMode:= bmOpaque;
            Texture.Image.LoadFromFile(fn);
            Texture.Disabled:= false;
            Texture.TextureMode:=tmModulate;
            FrontProperties.Diffuse.Red:=1;
            FrontProperties.Diffuse.Green:=1;
            FrontProperties.Diffuse.Blue:=1;
            FrontProperties.Diffuse.Alpha:=1;
          end;
        end;
        if level[i+1].pit=false then
        begin
          ppr[i]:=true;
          pitplaner[i]:=TGLPlane.CreateAsChild(gmbase);
          pitplaner[i].Width:=abs(level[i+1].fh-level[i].fh-bs);
          pitplaner[i].Height:=(level[i+1].w);
          pitplaner[i].position.y:=level[i].fh+pitplaner[i].Width/2;
          pitplaner[i].position.x:=floor[i].position.X+bs/2+0.01;
          pitplaner[i].Position.Z:=floor[i].Position.Z;
          pitplaner[i].Visible:=true;
          pitplaner[i].RollAngle:=90;
          pitplaner[i].PitchAngle:=90;
          fn:=gameexe+'\textures\'+inttostr(levelset)+'\1_bot.tga';
          if fileexists(fn)=false then fn:=gameexe+'\textures\'+inttostr(levelset)+'\1.tga';
          with pitplaner[i].Material do
          begin
            BlendingMode:= bmOpaque;
            Texture.Image.LoadFromFile(fn);
            Texture.Disabled:= false;
            Texture.TextureMode:=tmModulate;
            FrontProperties.Diffuse.Red:=1;
            FrontProperties.Diffuse.Green:=1;
            FrontProperties.Diffuse.Blue:=1;
            FrontProperties.Diffuse.Alpha:=1;
          end;
        end;
      end;
    end;


    flplane[i]:=TGLPlane.CreateAsChild(gmbase);
    flplane[i].Height:=(floor[i].CubeDepth);
    flplane[i].position.y:=level[i].fh+0.01;
    flplane[i].PitchAngle:=90;
    flplane[i].Width:=(bs);
    flplane[i].position.x:=level[i].x1+round(bs/2);;
    flplane[i].Visible:=true;
    if level[i].crusher=false then
      fn:=gameexe+'\textures\'+inttostr(levelset)+'\floor.tga'
    else
      fn:=gameexe+'\textures\'+inttostr(levelset)+'\crusher.tga';
    with flplane[i].Material do
    begin
      BlendingMode:= bmOpaque;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;

    bgtile[i]:=TGLSprite.CreateAsChild(gmbase);
    bgtile[i].Height:=abs(level[i].ch-level[i].fh);
    bgtile[i].Width:=(bs);
    //bgtile[i].CubeDepth:=round(bs/5)+random(round(bs));
    bgtile[i].position.y:=(level[i].fh)+bgtile[i].Height/2;
    bgtile[i].position.x:=level[i].x1+round(bs/2);
    bgtile[i].Position.Z:=-1;
    bgtile[i].Visible:=true;
    fn:=gameexe+'\textures\'+inttostr(levelset)+'\bg_'+IntToStr(Random(abgen))+'.tga';
    with bgtile[i].Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    fltile[i]:=TGLCube.CreateAsChild(gmbase);
    fltile[i].CubeHeight:=bs*2;
    fltile[i].CubeWidth:=(bs);
    //bgtile[i].CubeDepth:=round(bs/5)+random(round(bs));
    fltile[i].position.y:=(level[i].fh)-bs*2;
    fltile[i].position.x:=level[i].x1+round(bs/2);
    fltile[i].Position.Z:=floor[i].Position.Z;
    fltile[i].CubeDepth:=floor[i].CubeDepth;
    fltile[i].Visible:=true;
    fn:=gameexe+'\textures\'+inttostr(levelset)+'\1_bot.tga';
    if fileexists(fn)=false then fn:=gameexe+'\textures\'+inttostr(levelset)+'\1.tga';
    with fltile[i].Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    cltile[i]:=TGLSprite.CreateAsChild(gmbase);
    cltile[i].Height:=bs*2;
    cltile[i].Width:=(bs);
    //bgtile[i].CubeDepth:=round(bs/5)+random(round(bs));
    cltile[i].position.y:=(level[i].ch)+bs*2;
    cltile[i].position.x:=level[i].x1+round(bs/2);
    cltile[i].Position.Z:=ceil[i].CubeDepth/2;
    if lg_hasceil=true then
      cltile[i].Visible:=true
    else
      cltile[i].Visible:=false;
    fn:=gameexe+'\textures\'+inttostr(levelset)+'\2.tga';
    with cltile[i].Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    //ShowMessage('i='+inttostr(i));
  end;
  //ShowMessage('Floors and ceilings ready...');
  //setting background
  GLPlane1.Position.Z:=-40;//(-1)*round((bs/5)+(bs));
  GLPlane1.Width:=(bs*30)*(MSData.Width/800);
  GLPlane1.Height:=(bs*12)*(MSData.Height/600);

  //GLPlane1.Material.MaterialLibrary:=BGMatLib;
  if abg>0 then
  begin
    fn:=gameexe+'\bg\'+inttostr(lg_bgtl)+'.tga';
    with GLPlane1.Material do
    begin
      BlendingMode:= bmModulate;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmDecal;
      //FrontProperties.Diffuse.Red:=1;
      //FrontProperties.Diffuse.Green:=1;
      //FrontProperties.Diffuse.Blue:=1;
      //FrontProperties.Diffuse.Alpha:=1;
    end;
  end;
  //GLPlane1.Material.Texture.Disabled:=false;
  //ShowMessage('Background set...');
  //creating enemies
  for i:=0 to finalenemy do
  begin
    try
      FreeAndNil(esprites[i]);
    except
    end;
    if earr[i].alive=true then
    begin
      esprites[i]:=TGLSprite.CreateAsChild(gmbase);
      with esprites[i] do
      begin
        Width:=earr[i].size;
        Height:=earr[i].size;
        Position.X:=earr[i].x;
        Position.y:=earr[i].y;
        Position.Z:=0;
        esprites[i].Visible:=true;
        TGLSprite(esprites[i]).Material.MaterialLibrary:=ESpritesMatLib;
        {fn:=gameexe+'\esprites\e'+inttostr(earr[i].tp)+'_0.tga';
        with esprites[i].Material do
        begin
          BlendingMode:= bmTransparency;
          Texture.Image.LoadFromFile(fn);
          Texture.Disabled:= false;
          Texture.TextureMode:=tmModulate;
          FrontProperties.Diffuse.Red:=1;
          FrontProperties.Diffuse.Green:=1;
          FrontProperties.Diffuse.Blue:=1;
          FrontProperties.Diffuse.Alpha:=1;
        end;          }
        Visible:=true;
      end;
    end;
  end;
  //making bonuses
  for i:=0 to 100 do
  begin
    try FreeAndNil(bonsprites[i]); except end;
    if barr[i].alive=true then
    begin
      bonsprites[i]:=TGLSprite.CreateAsChild(gmbase);
      with bonsprites[i] do
      begin
        Width:=GLSphere1.Radius;
        Height:=GLSphere1.Radius;
        Position.X:=barr[i].x;
        Position.y:=barr[i].y;
        Position.Z:=0;
        bonsprites[i].Visible:=true;
        fn:=gameexe+'\Sprites\bonus_'+inttostr(barr[i].tp)+'.tga';
        with bonsprites[i].Material do
        begin
          BlendingMode:= bmTransparency;
          Texture.Image.LoadFromFile(fn);
          Texture.Disabled:= false;
          Texture.TextureMode:=tmModulate;
          FrontProperties.Emission.Red:=1;
          FrontProperties.Emission.Green:=1;
          FrontProperties.Emission.Blue:=1;
          FrontProperties.Emission.Alpha:=1;
        end;
        Visible:=true;
      end;
    end;
  end;

  //making decorations
  for i:=0 to 100 do
  begin
    if darr[i].tp<>-1 then
    begin
      try FreeAndNil(decsprites[i]); except end;
      decsprites[i]:=TGLSprite.CreateAsChild(gmbase);
      with decsprites[i] do
      begin
        decsprites[i].Width:=darr[i].sizex;
        decsprites[i].Height:=darr[i].sizey;
        Position.X:=darr[i].x;
        if darr[i].pos=2 then
          Position.y:=darr[i].y;
        if darr[i].pos=0 then
          Position.y:=darr[i].y+darr[i].sizey/2;
        if darr[i].pos=1 then
          Position.y:=darr[i].y-darr[i].sizey/2;
        Position.Z:=darr[i].z;
        fn:=gameexe+'\Textures\'+inttostr(levelset)+'\deco_'+inttostr(darr[i].tp)+'.tga';
        with decsprites[i].Material do
        begin
          BlendingMode:= bmTransparency;
          Texture.Image.LoadFromFile(fn);
          Texture.Disabled:= false;
          Texture.TextureMode:=tmModulate;
          FrontProperties.Emission.Red:=1;
          FrontProperties.Emission.Green:=1;
          FrontProperties.Emission.Blue:=1;
          FrontProperties.Diffuse.Alpha:=1;
        end;
        Visible:=true;
      end;
    end;
  end;

  LGen:=False;
end;

procedure TForm1.AssignPlayerSprite;
var fn,mn:string;
    fl:string;
    fso,actlev:integer;
begin
  GLSphere1.Visible:=false;
  case plr.state of
  0:begin
      fl:='s';
    end;
  1:begin
      fl:='j';
    end;
  2:begin
      fl:='h';
    end;
  3:begin
      fl:='d';
    end;
  4:begin
      fl:='m';
    end;
  5:begin
      fl:='w';
    end;
  6:begin
      fl:='w';
    end;
  end;
  actlev:=plr.lvl;
  if plr.lvl>5 then actlev:=5;
  if plr.hitstate>0 then fl:='h';
  if plr.morph>0 then fl:='m';
  mn:=inttostr(actlev)+'_'+fl+'_2_'+inttostr(plr.paframe);
  //fn:=gameexe+'\Sprites\'+inttostr(plr.lvl)+'\'+fl+'_2_'+inttostr(plr.paframe)+'.tga';
  if fl='j' then
  begin
    if plr.ky<0 then mn:=inttostr(actlev)+'_'+fl+'_1_0';
    if plr.ky>=0 then mn:=inttostr(actlev)+'_'+fl+'_2_0';
  end;
  if fl='h' then
  begin
    mn:=inttostr(actlev)+'_'+fl+'_2_0';
  end;
  if fl='m' then
  begin

    if plr.morph=10 then
      mn:=inttostr(actlev)+'_'+fl+'_2_'+inttostr(plr.morph-1)
    else
      mn:=inttostr(actlev)+'_'+fl+'_2_'+inttostr(plr.morph);
  end;
  //!!!!!!!
  //TGLSprite(GLSprite1).Material.LibMaterialName:='Tile'+inttostr(field[x,y]);
  //!!!!!!!
  try
    if (fl<>'d') then
      TGLSprite(GLSprite1).Material.LibMaterialName:=mn;
  except
    //FillMLibraries;
  end;
  if plr.face=1 then
    GLSprite1.MirrorU:=true
  else
    GLSprite1.MirrorU:=false;
  {if fileexists(fn) then
  begin

    GLSprite1.Visible:=true;
    with GLSprite1.Material do
    begin
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      BlendingMode:= bmTransparency;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;

  end
  else
  begin
    GLSphere1.Visible:=true;
    GLSprite1.Visible:=false;
  end; }
end;

procedure TForm1.ShowAtBottom(txt:string);
begin
  ctextmsg:=txt;
  bottomtext.Position.Y:=GLSceneViewer1.Height-31;
end;

procedure TForm1.KillPlayer;
begin
  //ShowMessage('You die!');
  cbl:=cp;
  plr.x:=cp*bs+bs/2;
  plr.y:=level[cbl].fh+2;
  plr.kx:=0;
  plr.face:=0;
  plr.ix:=0;
  plr.hp:=plr.hpmax;
  if hardcore=true then
  begin
    plr.lives:=plr.lives-1;
    ShowAtBottom(inttostr(plr.lives)+' lives left.');
    //ShowMessage(inttostr(plr.lives)+' lives left.');
  end;
  if earr[100].alive=true then
  begin
    earr[100].hp:=earr[100].hp+round(earr[100].hp*0.2);
    if earr[100].hp>earr[100].hpmax then earr[100].hp:=earr[100].hpmax;
  end;
  {if plr.xp=0 then
  begin
    SwitchLevel(levelset);
    plr.x:=bs/2;
    cbl:=0;
    cp:=0;
  end;}
  if plr.xp<plr.xpreq/2 then
    plr.xp:=0
  else
    plr.xp:=round(plr.xpreq/2);
  bitex:=gameexe+'\textures\death.tga';
  showbi:=30;
  if plr.lives<0 then
  begin
    //ShowMessage('You died!');
    ShowAtBottom('You died!');
    ResetGame;
    gamestate:=0;
  end;
end;


procedure TForm1.processenemysprites;
var i:integer; fn,mn:string;
begin
  //assigns right sprites for the enemies
  for i:=0 to 100 do
  begin
    //if (barr[i].alive=true) and (abs(earr[i].x-plr.x)<(bs*5)) then
    //begin
    //
    //end;
    if (earr[i].alive=true) and (abs(earr[i].x-plr.x)<(bs*5)) then
    begin

      {if (earr[i].aggr>0) then
      begin
        esprites[i].Width:=earr[i].size*(((200-earr[i].aggr)/200));
        esprites[i].Width:=esprites[i].Height;
      end;}
      mn:='e'+inttostr(earr[i].tp)+'_'+inttostr(earr[i].state);
      TGLSprite(esprites[i]).Material.LibMaterialName:=mn;
      {fn:=gameexe+'\esprites\e'+inttostr(earr[i].tp)+'_'+inttostr(earr[i].state)+'.tga';
      if fileexists(fn)=true then
      with esprites[i].Material do
      begin
        BlendingMode:= bmTransparency;
        Texture.Image.LoadFromFile(fn);
        Texture.Disabled:= false;
        Texture.TextureMode:=tmModulate;
        FrontProperties.Diffuse.Red:=1;
        FrontProperties.Diffuse.Green:=1;
        FrontProperties.Diffuse.Blue:=1;
        FrontProperties.Diffuse.Alpha:=1;
      end;          }
      if plr.x>earr[i].x then
      begin
        try esprites[i].MirrorU:=true; except end;
      end
      else
      begin
        try esprites[i].MirrorU:=false; except end;
      end;
    end;
    if earr[i].alive=true then
    with earr[i] do
      begin
        If blink>0 then
        begin
          if blink mod 2 = 0 then
          begin
            esprites[i].Visible:=true;
          end
          else
          begin
            esprites[i].Visible:=false;
          end;
          blink:=blink-1;
        end;
      end;
    if (earr[i].alive=false) then
    begin
      try FreeAndNil(esprites[i]); except end;
    end;
    if (barr[i].alive=false) then
    begin
      try FreeAndNil(bonsprites[i]); except end;
    end;
  end;

end;


procedure TForm1.DamageArea(sender:integer;fxid:string;x,y,area:real; dmg:integer; splode:boolean; snd:string);
var i:integer;
begin
  if musicon=true then
    PlaySound(PWideChar(gameexe+'\sound\'+snd+'.wav'),0,SND_ASYNC);
  if sender=1 then
  begin
    if ((plr.x+(GLSphere1.Radius/4))>(x-(area/2))) and
       ((plr.x-(GLSphere1.Radius/4))<(x+area/2)) and
       ((plr.y+GLSphere1.Radius/2)>(y-(area/2))) and ((plr.y)<(y+area/2)) and
       (plr.shield=0) and (plr.invuln=false) then
    begin
      if splode=false then
        plr.hp:=plr.hp-dmg
      else
      begin
        plr.hp:=round(plr.hp-dmg*abs((plr.x-x)/(area/2))*abs((plr.y-y)/(area/2)));
      end;
      showrs:=10;
      //GLLightSource1.ConstAttenuation:=0;
      //GLLightSource1.Diffuse.Red:=1;
      //GLLightSource1.Diffuse.Green:=0;
      //GLLightSource1.Diffuse.Blue:=0;
      if plr.hp<=0 then
      begin
        plr.hp:=0;
        KillPlayer;
      end;

    end;
  end;
  if sender=0 then
  begin
    tothpdam:=0;
    for i:=0 to 100 do
    begin
      if earr[i].alive=true then
      if ((earr[i].x+earr[i].size/3)>(x-area/2)) and ((earr[i].x-earr[i].size/3)<(x+area/2)) and
         ((earr[i].y+earr[i].size/3)>(y-area/2)) and ((earr[i].y-earr[i].size/3)<(y+area/2)) then
      begin
        //calculating damage:
        if earr[i].hp>=dmg then
          tothpdam:=tothpdam+dmg
        else
          tothpdam:=tothpdam+earr[i].hp;

        earr[i].hp:=earr[i].hp-dmg;

        earr[i].blink:=10;
        if earr[i].hp<=0 then
        begin
          plr.xp:=plr.xp+earr[i].xpval;
          points:=points+earr[i].xpval;
          if earr[i].deatheffect<>'nil' then
            DropEffect(earr[i].x,earr[i].y,earr[i].size,earr[i].deatheffect);
          earr[i].alive:=false;

        end;
      end;
    end;
  end;
  try
    DropEffect(x,y,area,fxid);
  except
  end;
end;

procedure TForm1.processgui;
var sts:real;
    fn:string;
    hpmw,engmw,hpw,engw,xpw,xpmw,recw,recwm:integer;
    bhpw:integer;
    tih,tihm:real;
    abstate:string;
    abno:integer;

begin
  //assigning HP and energy bars
  //try
    AddRL('Processing GUI');
    hpsprite.Height:=10;
    bosshpsprite.Height:=10;
    xpsprite.Height:=10;
    engsprite.Height:=10;
    recsprite.Height:=10;
    tisprite.Height:=100;
    tisprite.Width:=16;
    hpbg.Height:=16;
    bosshpbg.Height:=16;
    engbg.Height:=16;
    xpbg.Height:=16;
    recbg.Height:=16;
    tibg.Height:=100;
    tibg.Width:=16;
    hpw:=round(plr.hp*(100/plr.hpmax));
    hpsprite.Width:=hpw;
    hpbg.Width:=100;
    bhpw:=round(earr[100].hp*((GLSceneViewer1.Width-240)/earr[100].hpmax));
    bosshpsprite.Width:=bhpw;
    bosshpbg.Width:=GLSceneViewer1.Width-240;
    tibg.Height:=100;
    engw:=round(plr.eng*(100/plr.engmax));
    engsprite.Width:=engw;
    engbg.Width:=100;
    xpmw:=100;
    if plr.xpreq=0 then plr.xpreq:=1;
    xpw:=round(plr.xp*(100/plr.xpreq));
    xpbg.Width:=100;
    xpsprite.Width:=xpw;
    recw:=round((plr.hitrecbase-plr.hitrec)*(100/plr.hitrecbase));
    recwm:=plr.hitrecbase;
    recbg.Width:=100;
    recsprite.Width:=recw;
    tih:=round(timeleft*(100/timetot));
    tisprite.Height:=tih;
    hpsprite.Position.X:=10+hpsprite.Width/2;
    bosshpsprite.Position.X:=120+hpsprite.Width/2;
    xpsprite.Position.X:=10+xpsprite.Width/2;
    engsprite.Position.X:=10+engsprite.Width/2;
    recsprite.Position.X:=10+recsprite.Width/2;
    tisprite.Position.X:=GLSceneViewer1.Width-10-tisprite.Width/2;
    tisprite.Position.Y:=60;
    tibg.Position.Y:=60;
    tibg.Position.X:=tisprite.Position.X;
    hpbg.Position.X:=10+hpbg.Width/2;
    bosshpsprite.Position.X:=120+bosshpsprite.Width/2;
    bosshpsprite.Position.Y:=20;
    bosshpbg.Position.X:=120+bosshpbg.Width/2;
    bosshpbg.Position.Y:=20;
    engbg.Position.X:=10+engbg.Width/2;
    xpbg.Position.X:=10+xpbg.Width/2;
    recbg.Position.X:=10+recbg.Width/2;
    hpsprite.Position.Y:=10;
    engsprite.Position.Y:=10+hpsprite.Height+10;
    xpsprite.Position.Y:=10+hpsprite.Height+10+engsprite.Height+10;
    recsprite.Position.Y:=10+hpsprite.Height+10+engsprite.Height+10+xpsprite.Height+10;
    hpbg.Position.Y:=hpsprite.Position.Y;
    engbg.Position.Y:=engsprite.Position.Y;
    xpbg.Position.Y:=xpsprite.Position.Y;
    recbg.Position.Y:=recsprite.Position.Y;

    pointstext.Position.X:=GLSceneViewer1.Width-200;
    pointstext.Position.Y:=10;
    pointstext.Text:=inttostr(points);

    //bottomtext.Position.Y:=GLSceneViewer1.Height-30;

    if (bosshpsprite.Visible=true) and (earr[100].alive=false) then
    begin
      bosshpsprite.Visible:=false;
    end;
    if (bosshpsprite.Visible=false) and (earr[100].alive=true) then
    begin
      bosshpsprite.Visible:=true;
    end;
    if (bosshpbg.Visible=true) and (earr[100].alive=false) then
    begin
      bosshpbg.Visible:=false;
    end;
    if (bosshpbg.Visible=false) and (earr[100].alive=true) then
    begin
      bosshpbg.Visible:=true;
    end;
    //hpsprite.Position.Z:=Camera.Position.Z-bs;
    //engsprite.Position.Z:=Camera.Position.Z-bs;
    //hpbg.Position.Z:=0;
    //engbg.Position.Z:=0;
    //hpsprite.Position.Z:=0;
    //engsprite.Position.Z:=0;
    hpsprite.MoveFirst;
    engsprite.MoveFirst;
    //hpbg.MoveLast;
    //engbg.MoveLast;
    //hpbg.Visible:=false;
    //engbg.Visible:=false;
    with lvlupsprite do
    begin
      Height:=100;
      width:=300;

      Position.X:=MSData.Width/2;
      Position.Y:=MSData.Height-50;
    end;
    if (wannalevelup=true) and (lvlupsprite.Visible=false) then
    begin
      lvlupsprite.Visible:=true;
    end;
    if (wannalevelup=false) and (lvlupsprite.Visible=true) then
    begin
      lvlupsprite.Visible:=false;
    end;

    //big central banner
    if showbi>0 then
    with biginput do
    begin
      biginput.Visible:=true;
      fn:=bitex;
      with biginput.Material do
      begin
        BlendingMode:= bmTransparency;
        Texture.Image.LoadFromFile(fn);
        Texture.Disabled:= false;
        Texture.TextureMode:=tmModulate;
        FrontProperties.Emission.Red:=1;
        FrontProperties.Emission.Green:=1;
        FrontProperties.Emission.Blue:=1;
        if showbi>10 then
          FrontProperties.Diffuse.Alpha:=1
        else
          FrontProperties.Diffuse.Alpha:=showbi/10;
      end;
      biginput.Height:=200;
      biginput.Width:=400;
      biginput.Position.X:=MSData.Width/2;
      biginput.Position.Y:=20+biginput.Height/2;
      Visible:=true;
    end
    else
      biginput.Visible:=false;

  //ability state icons
  with TGLHUDSprite(ab_1) do
  begin
    abno:=1;
    if plr.eng>20 then abstate:='a' else abstate:='na';
    Material.LibMaterialName:='ab_'+inttostr(abno)+'_'+abstate;
    width:=60;
    Height:=60;
    if plr.lvl>=abno then Visible:=true else Visible:=false;
    Position.X:=10*abno+(width/2)*abno;
    Position.Y:=MSData.Height-10-height/2;
  end;
  with TGLHUDSprite(ab_2) do
  begin
    abno:=2;
    if plr.eng>=30 then abstate:='a' else abstate:='na';
    Material.LibMaterialName:='ab_'+inttostr(abno)+'_'+abstate;
    width:=60;
    Height:=60;
    if plr.lvl>=abno then Visible:=true else Visible:=false;
    Position.X:=10+ab_1.Position.X+(width);
    Position.Y:=MSData.Height-10-height/2;
  end;
  with TGLHUDSprite(ab_3) do
  begin
    abno:=3;
    if plr.eng>=10 then abstate:='a' else abstate:='na';
    Material.LibMaterialName:='ab_'+inttostr(abno)+'_'+abstate;
    width:=60;
    Height:=60;
    if plr.lvl>=abno then Visible:=true else Visible:=false;
    Position.X:=10+ab_2.Position.X+(width);
    Position.Y:=MSData.Height-10-height/2;
  end;
  with TGLHUDSprite(ab_4) do
  begin
    abno:=4;
    if plr.eng>=500/plr.intelligence then abstate:='a' else abstate:='na';
    Material.LibMaterialName:='ab_'+inttostr(abno)+'_'+abstate;
    width:=60;
    Height:=60;
    if plr.lvl>=abno then Visible:=true else Visible:=false;
    Position.X:=10+ab_3.Position.X+(width);
    Position.Y:=MSData.Height-10-height/2;
  end;
  with TGLHUDSprite(ab_5) do
  begin
    abno:=5;
    if plr.eng=plr.engmax then abstate:='a' else abstate:='na';
    Material.LibMaterialName:='ab_'+inttostr(abno)+'_'+abstate;
    width:=60;
    Height:=60;
    if plr.lvl>=abno then Visible:=true else Visible:=false;
    Position.X:=10+ab_4.Position.X+(width);
    Position.Y:=MSData.Height-10-height/2;
  end;
  //except end;
  if showrs>0 then
    with redsplash do
    begin
      redsplash.Visible:=true;
      //fn:=bitex;
      with redsplash.Material do
      begin
        //BlendingMode:= bmTransparency;
        //Texture.Image.LoadFromFile(fn);
        //Texture.Disabled:= false;
        //Texture.TextureMode:=tmModulate;
        //FrontProperties.Emission.Red:=1;
        //FrontProperties.Emission.Green:=1;
        //FrontProperties.Emission.Blue:=1;
        if showrs>10 then
          FrontProperties.Diffuse.Alpha:=1
        else
          FrontProperties.Diffuse.Alpha:=showrs/10;
      end;
      redsplash.Height:=GLSceneViewer1.Height;
      redsplash.Width:=GLSceneViewer1.Width;
      redsplash.Position.X:=GLSceneViewer1.Width/2;
      redsplash.Position.Y:=GLSceneViewer1.Height/2;
      Visible:=true;
    end
    else
      redsplash.Visible:=false;

end;


procedure TForm1.SpawnMissile(md,mx,my,mkx,mky,mspd,mspdy,mdmg,mboomd:real;g,b:boolean;mname:string);
var i:integer;
begin
  //creates a missile at a point
  i:=-1;
  repeat
    i:=i+1;
  until (marr[i].alive=false) or (i>(maxmiss-1));
  //ShowMessage('i in mspawn = '+inttostr(i));
  if i<=(maxmiss-1) then
  begin
    //missiles[i]:=TGLSphere.CreateAsChild(gmbase);
    missiles[i].Visible:=true;
    with marr[i] do
    begin
      alive:=true;
      kx:=mkx;
      ky:=mky;
      x:=mx;
      y:=my;
      spd:=mspd;
      spdy:=mspdy;
      dmg:=round(mdmg);
      grav:=g;
      bu:=b;
      brad:=mboomd;
      d:=md;
      name:=mname;
    end;
    missiles[i].Material.LibMaterialName:='bull_'+marr[i].name;
    if musicon=true then
    begin
      if b=false then
        PlaySound(PWideChar(gameexe+'\sound\shot.wav'),0,SND_ASYNC)
      else
        PlaySound(PWideChar(gameexe+'\sound\grenade.wav'),0,SND_ASYNC)
    end;
  end;
  //else
  //ShowMessage('Can`t spawn a missile!');
end;

procedure TForm1.PushPlrAway(px,py:real; force:real);
begin
  if (abs(px-plr.rx)<(GLSphere1.Radius/2)) and
     (abs(py-plr.ry)<(GLSphere1.Radius)) then
  begin
    plr.pushed:=round(force/2);
    plr.state:=1;
    plr.iy:=force/3;
    plr.ky:=1;
    if plr.x<px then
      plr.kx:=-1
    else
      plr.kx:=1;
    plr.ix:=force;
  end;
end;


procedure TForm1.RecalcPositions;
var cblx,bch,obl,cfh:integer;
    i,j:integer;
    sts:real;
    ekx,eky,cky:real;

begin

  managewalking(plr.wkdir);

  //recalculates all objects positions

  //assigning camera and bg to player pos
  plr.rx:=plr.x;
  plr.ry:=plr.y+GLSphere1.Radius;
  GLSphere1.Position.X:=plr.rx;
  GLSphere1.Position.Y:=plr.ry;
  GLSprite1.Position.X:=plr.x;
  GLSprite1.Position.Y:=plr.y+GLSphere1.Radius;
  GLPlane1.Position.X:=plr.x;
  GLPlane1.Position.Y:=plr.y+2;
  GLPlane1.Position.Z:=-40;//(-1)*round((bs/5)+(bs));
  GLPlane1.Width:=1.1*mmbg.Width*5;
  GLPlane1.Height:=1.1*mmbg.Height*5;
  GLLightSource1.Position.X:=plr.x;
  GLLightSource1.Position.Y:=plr.y+GLSphere1.Radius*2;
  //GLLightSource1.Position.Y:=GLLightSource1.Position.Y+0.1*lky;
  if GLLightSource1.Position.Y>20 then
  begin
   lky:=-1;
  end;
  if GLLightSource1.Position.Y<-20 then
  begin
   lky:=1;
  end;
  GLLightSource1.Position.Z:=Camera.Position.Z;
  shields.Position.X:=GLSphere1.Position.X;
  shields.Position.Y:=GLSphere1.Position.Y;
  shields.Position.Z:=GLSphere1.Position.Z-0.01;
  shields.Material.FrontProperties.Diffuse.Alpha:=(plr.shield)/30;
  //GLLightSource2.Position.X:=plr.x;
  //GLLightSource2.Position.Y:=plr.y+bs/2;
  //GLLightSource2.Position.Z:=Camera.Position.Z/2;
  Camera.Position.X:=plr.x;
  if Camera.Position.Y<(plr.y+GLSphere1.Radius) then cky:=1 else cky:=-1;
  if Camera.Position.Y<>plr.y+GLSphere1.Radius then
    Camera.Position.Y:=Camera.Position.Y+0.01*cky;
  if (Camera.Position.Y<(-1.5*bs)) then
  begin
    Camera.Position.Y:=-1.5*bs;
  end;
  if plr.morph>0 then
  begin
    Camera.Position.Z:=15;
    plr.invuln:=true;
  end
  else
  begin
    Camera.Position.Z:=30*(workdist/10);
    plr.invuln:=false;
  end;
  if  GLSceneViewer1.Height<>654 then
  begin
    Camera.SceneScale:=GLSceneViewer1.Height/654;
  end;
  //working on player
  with plr do
  begin
    //working on xp
    if xp>xpreq then
    begin
      if musicon=true then
        PlaySound(PWideChar(gameexe+'\sound\morph.wav'),0,SND_ASYNC);
      ShowAtBottom('Level up! Press NUMPAD 1, 2 or 3');
      if gamemode=0 then
      begin
        lvl:=lvl+1;
        if lvl>5 then lvl:=5;
      end;
      plevel:=plevel+1;
      xpreq:=xpreq*2;
      xp:=0;
      wannalevelup:=true;
      if gamemode=0 then
      begin
        plr.morph:=10;
        ix:=0;
      end;
      plr.hp:=plr.hpmax;
    end;

    //assigning player stats, repelishing energy, etc.
    hpmax:=strength*10;
    if hp>hpmax then hp :=hpmax;
    engmax:=intelligence*10;
    if eng>engmax then eng:=engmax;
    spd:=420-speed*2;
    hitrecbase:=round(200/speed);
    if (eng<engmax) then
    begin
      if earr[100].alive=false then
        eng:=eng+(intelligence/8000)
      else
        eng:=eng+(intelligence/4000);
      if eng>engmax then eng:=engmax;
    end;
    //getting current block
    cblx:=round(x);
    while (cblx mod bs) <> 0 do
    begin
      cblx:=cblx-1;
    end;
    if (GetCBL(x)<>cbl) then
    begin
      bch:=1; obl:=cbl;
    end
    else bch:=0;
    cbl:=GetCBL(x);

    if ((cbl mod 20) = 0) and (cp<>cbl) and (cbl<>0) and
       (level[cbl].pit<>true) and (level[cbl].crusher<>true)then
    begin
      cp:=cbl;
      bitex:=gameexe+'\textures\checkpoint.tga';
      showbi:=30;
    end;

    //calculating collisions
    xcol:=0;
    ycol:=0;
    //checking collisions with decorations
    ondeco:=false;
    if (decsav>0) then
    for j:=0 to 100 do
    begin

       if (darr[j].pos=2) and
         ((plr.x)>(darr[j].x-darr[j].sizex/2)) and
         ((plr.x)<(darr[j].x+darr[j].sizex/2)) and
         ((plr.y)<=(darr[j].y+darr[j].sizey/2)) and
         ((plr.y)>=(darr[j].y+(darr[j].sizey/2)-plr.iy)) and
         (darr[j].solid=true) and
         (plr.y>level[GetCBL(plr.x)].fh) then
      begin
        plr.y:=darr[j].y+darr[j].sizey/2; ondeco:=true;
        if state=1 then
        begin
          plr.state:=0;
        end;
        iy:=0;
        ky:=0;
      end;

      if (darr[j].pos=0) and
         ((plr.x)>(darr[j].x-darr[j].sizex/2)) and
         ((plr.x)<(darr[j].x+darr[j].sizex/2)) and
         (plr.y<=(darr[j].y+darr[j].sizey)) and
         (plr.y>=(darr[j].y+darr[j].sizey-plr.iy)) and
         (darr[j].solid=true) and
         (plr.y>level[GetCBL(plr.x)].fh) then
      begin
        plr.y:=darr[j].y+darr[j].sizey;  ondeco:=true;
        if state=1 then
        begin
          plr.state:=0;
        end;
        iy:=0;
        ky:=0;
      end;


    end;

    if (state=0) and (ondeco=true) then iy:=0;

    //checking collisions with blocks
    if y<level[cbl].fh then
    begin
      if bch=1 then
      begin
        xcol:=1;
        if (level[cbl].fh-level[obl].fh)<GLSphere1.Radius/2 then
        begin
          y:=level[cbl].fh;
        end
        else
        begin
          if kx>0 then
          begin
            x:=level[obl].x1+bs-GLSphere1.Radius/4;
            ix:=0;
          end;
          if kx<0 then
          begin
            x:=level[obl].x1+GLSphere1.Radius/4;
            ix:=0;
          end;
          ix:=1;
          kx:=(-1)*kx;
          plr.foix:=5;
          plr.ixtf:=1;
          plr.kxtf:=plr.kx;
          //y:=level[obl].fh;
        end;
      end
      else
      begin
        y:=level[cbl].fh;
        iy:=0;
        xcol:=0;
      end;
      iy:=0;
      ky:=0;

    end;

    if y>(level[cbl].ch-GLSphere1.Radius*2) then
    begin
      if bch=1 then
      begin
        //kx:=0;
        ix:=0;
        xcol:=1;
        x:=(level[getcbl(x)].x1+bs/2)-((bs/2)*kx*1.01);
      end;
      if bch=0 then
      begin
        y:=level[cbl].ch-0.1-GLSphere1.Radius*2;
        iy:=0;
      end;
    end;

    py:=y;
    px:=x;

    //processing "physics"

    if (y>level[cbl].fh) and (ky<=0) and (ondeco=false)  then
    begin
      iy:=iy+g/2000;
      ky:=-1;
    end;
    if (ky>0)  then
    begin
      iy:=iy-g/2000;
      ky:=1;
      if (iy<=0) then  begin ky:=-1; iy:=0; end;
    end;
    if (iy<>0) and (ky<>0)  then
    begin
      y:=y+(iy/spd)*ky;
    end;
    if (ix>0) and (xcol<>1) then
    begin
      x:=x+(ix/spd)*(speed/10)*kx;
    end;
    if x<0 then
    begin
      x:=1;
      ix:=0;
    end;
    if (x>(lvllength+1)*(bs)) then
    begin
      x:=lvllength*bs-1;
      ix:=0;
    end;
    //changing ix

    //ix:=ix-0.01;
    //if ix<0 then ix:=0;

    if (abs(level[cbl].fh-y)<0.5) and (hawkfall=true) then
    begin
      if plr.lvl<3 then
        DamageArea(0,'fx_-1',x,y+GLSphere1.Radius,GLSphere1.Radius*(plr.strength)/3,plr.strength*2,false,'hit')
      else
        DamageArea(0,'fx_-1',x,y+GLSphere1.Radius,GLSphere1.Radius*(plr.strength)/2,plr.strength*2,true,'hit');
      hawkfall:=false;
      //ShowMessage('Hawkfall!');
    end;
    //final state management
    if (iy<>0) and (ky<>0) then plr.state:=1;
    if ((iy=0) or (ky=0)) and (kx<0) then plr.state:=5;
    if ((iy=0) or (ky=0)) and (kx>0) then plr.state:=6;
    if ((iy=0) and (ky=0)) and (kx=0) then plr.state:=0;

    //checking deathstates
    if (y<=(2.5*bs*(-1))) or //fall into pit
       ((abs(level[cbl].ch-level[cbl].fh)<(GLSphere1.Radius*2)) and (level[cbl].ky<0)) then //crushered
    begin
      KillPlayer;
    end;

    if plr.hp<-0 then
    begin
      KillPlayer;
    end;
  end;

  //moving crushers
    for i:=0 to 100 do
    begin
        if level[i].crusher=true then
        begin
          if level[i].ch>=level[i].bch then
          begin
            level[i].ky:=-1;
          end;
          if level[i].ch<=level[i].fh then
          begin
            level[i].ky:=1;
          end;
          level[i].ch:=level[i].ch+level[i].spd*level[i].ky;
          ceil[i].position.y:=level[i].ch+(ceil[i].CubeHeight/2);
          crushercyl[i].Position.Y:=level[i].ch+bs*3;
        end;
    end;

  //processing enemies
    for i:=0 to 100 do
    begin
      if (earr[i].alive=true) and (abs(earr[i].x-plr.x)<(workdist*bs)) then
      begin
        //positioning sprites
        with esprites[i].Position do
        begin
          x:=earr[i].x;
          y:=earr[i].y;
        end;
        //checking what should do each type of enemy each tick
        case earr[i].tp of
        0:begin

            if abs(earr[i].x-plr.x)<(bs*workdist) then
            begin
              if (sticker mod 20 = 0) then
              begin
                if (earr[i].state=1) and (earr[i].aggr=1) then DamageArea(1,'fx_0',earr[i].x,earr[i].y,(earr[i].size*5),earr[i].attack,false,'discharge');
                if (earr[i].aggr=0) and (earr[i].state=1) then
                  earr[i].state:=0;
                if earr[i].aggr>0 then
                  earr[i].aggr:=earr[i].aggr-1;
                if (random(earr[i].ac)<3) and (earr[i].state<>1) then
                begin
                  earr[i].state:=1;
                  earr[i].aggr:=200;
                  //ShowMessage('Attack!');
                end;
              end;
            end;

          end;

        1:begin

            if abs(earr[i].x-plr.x)<(bs*workdist) then
            begin
              PushPlrAway(earr[i].x,earr[i].y,10);
              if (sticker mod 20 = 0) then
              begin
                if (earr[i].state=1) and (earr[i].aggr=1) then
                begin
                  if (plr.x<earr[i].x) then ekx:=-1 else ekx:=1;
                  SpawnMissile(0.3,earr[i].x,earr[i].y,ekx,0,0.01,0,earr[i].attack,0,false,false,'gauss');
                end;
                if (earr[i].aggr=0) and (earr[i].state=1) then
                  earr[i].state:=0;
                if earr[i].aggr>0 then
                  earr[i].aggr:=earr[i].aggr-1;
                if (random(earr[i].ac)<3) and (earr[i].state<>1) then
                begin
                  earr[i].state:=1;
                  earr[i].aggr:=earr[i].rectime;
                  //ShowMessage('Attack!');
                end;
              end;

            end;

          end;

        2:begin

            if (Abs(earr[i].x-plr.x)<=GLSphere1.Radius) and
               (Abs(earr[i].y-(plr.y+GLSphere1.Radius))<=(GLSphere1.Radius)) then
            begin
              earr[i].alive:=False;
              plr.hp:=plr.hp+10;
              if plr.hp>plr.hpmax then plr.hp:=plr.hpmax;
            end;

          end;


         3:begin

            if abs(earr[i].x-plr.x)<(bs*workdist) then
            begin
              PushPlrAway(earr[i].x,earr[i].y,10);
              if (sticker mod 20 = 0) then
              begin
                if (earr[i].state=1) and (earr[i].aggr=1) then
                begin
                  if (plr.x<earr[i].x) then ekx:=-1 else ekx:=1;
                  SpawnMissile(0.6,earr[i].x,earr[i].y,ekx,1,0.01,0.01,earr[i].attack,GLSphere1.Radius*2,true,True,'grenade');
                end;
                if (earr[i].aggr=0) and (earr[i].state=1) then
                  earr[i].state:=0;
                if earr[i].aggr>0 then
                  earr[i].aggr:=earr[i].aggr-1;
                if (random(earr[i].ac)<3) and (earr[i].state<>1) then
                begin
                  earr[i].state:=1;
                  earr[i].aggr:=earr[i].rectime;
                  //ShowMessage('Attack!');
                end;
              end;

            end;

          end;



          4:begin


            if earr[i].y<earr[i].y1 then
            begin
              earr[i].ky:=0.005;
            end;
            if earr[i].y>earr[i].y2 then earr[i].ky:=(-0.005);
            earr[i].y:=earr[i].y+earr[i].ky;

            if abs(earr[i].x-plr.x)<(bs*workdist) then
            begin

              if (sticker mod 20 = 0) then
              begin
                if (earr[i].state=1) and (earr[i].aggr=1) then
                begin
                  if (plr.x<earr[i].x) then ekx:=-1 else ekx:=1;
                  //if (Random(100)<2) and (earr[i].state=0) then
                  begin
                    if earr[i].y>earr[i].y2-bs/2 then
                      SpawnMissile(0.3,earr[i].x,earr[i].y,ekx,-1,0.01,0.001,earr[i].attack,0,false,false,'gauss');
                    if earr[i].y<earr[i].y1+bs/2 then
                      SpawnMissile(0.3,earr[i].x,earr[i].y,ekx,1,0.01,0.001,earr[i].attack,0,false,false,'gauss');
                    if (earr[i].y>=earr[i].y1+bs/2) and (earr[i].y<=earr[i].y2-bs/2) then
                      SpawnMissile(0.3,earr[i].x,earr[i].y,ekx,0,0.01,0,earr[i].attack,0,false,false,'gauss');
                    //earr[i].state:=1;
                  end;
                end;
                if (earr[i].aggr=0) and (earr[i].state=1) then
                  earr[i].state:=0;
                if earr[i].aggr>0 then
                  earr[i].aggr:=earr[i].aggr-1;
                if (random(earr[i].ac)<3) and (earr[i].state<>1) then
                begin
                  earr[i].state:=1;
                  earr[i].aggr:=earr[i].rectime;
                  //ShowMessage('Attack!');
                end;
              end;

            end;
            end;

          5:begin

              with earr[i] do
              begin
                if (abs(x-plr.rx)<(GLSphere1.Radius*0.7)) and (abs(y-plr.ry)<(GLSphere1.Radius*0.7)) then
                begin
                  //ShowMessage('KABOOM!');
                  DamageArea(1,'slime',earr[i].x,earr[i].y,(GLSphere1.Radius*3),earr[i].attack,true,'splash');
                  alive:=false;
                end;
                {if (state=1) and (abs(x-plr.x)<(GLSphere1.Radius*0.7)) and (abs(y-plr.y)>(GLSphere1.Radius*0.7)) then
                begin
                  iy:=9;
                  ky:=1;
                end;     }
                if (abs(x-plr.x)<(bs*workdist)) and (state=1) then
                begin
                  x:=x+abs(ix*0.001)*kx;
                  y:=y+abs(iy*0.001)*ky;
                  iy:=iy-0.01;
                  if iy<0 then ky:=-1 else ky:=1;
                  if y<level[GetCBL(x)].fh then
                  begin
                    ix:=0;
                    iy:=0;
                    state:=0;
                    kx:=0;
                    ky:=0;
                    y:=level[GetCBL(x)].fh+size/2;
                  end;
                end;
                if (abs(x-plr.x)>(bs*3)) and (abs(x-plr.x)<(bs*6)) and (state=0) then
                begin
                  state:=0;
                  kx:=0;
                  ky:=0;
                  ix:=0;
                  iy:=0;
                end;
                if (abs(x-plr.x)<(bs*3)) and (state=0) then
                begin
                  //
                  state:=1;
                  if plr.x<x then
                    kx:=-1
                  else
                    kx:=1;
                  ky:=1;
                  if (abs(x-plr.x)<(bs*3)) then
                  begin
                    ix:=15;
                    iy:=5+random(10);
                  end;
                  if (abs(x-plr.x)<(bs*1.5)) then
                  begin
                    ix:=8;
                    iy:=2+random(5);
                  end;
                end;
              end;

            end;


          6:begin

            earr[i].ix:=0.01;
            earr[i].iy:=0.005;

            if ((abs(earr[i].x-earr[i].x1)<=1) and (abs(earr[i].y-earr[i].y1)<=1))
               or ((abs(earr[i].x-plr.x)>=bs*4) and (abs(earr[i].y-plr.y)>=bs*3)) or
               (earr[i].y<plr.y+bs) then
            begin
              earr[i].desx:=(Random(round(bs*4))-bs*2);
              earr[i].desy:=bs+Random(round(bs*3));
            end;

            {if (abs(earr[i].iy)<=0.02) then
              earr[i].iy:=earr[i].iy+earr[i].ky*0.0000001;
            if abs(earr[i].ix)<=0.02 then
              earr[i].iy:=earr[i].iy+earr[i].ky*0.0000005;}

            earr[i].x1:=plr.x+earr[i].desx;
            earr[i].y1:=plr.y+earr[i].desy;

            if (earr[i].x<earr[i].x1) then
              earr[i].kx:=1
            else
              earr[i].kx:=-1;
            earr[i].x:=earr[i].x+earr[i].ix*earr[i].kx;
            if (earr[i].y<earr[i].y1) then
              earr[i].ky:=1
            else
              earr[i].ky:=-1;
            earr[i].y:=earr[i].y+earr[i].iy*earr[i].ky;


            if abs(earr[i].x-plr.x)<(bs*workdist) then
            begin
              PushPlrAway(earr[i].x,earr[i].y,10);
              if (sticker mod 100 = 0) and (earr[i].aggr mod 25 = 0) then
              begin
                if (plr.x<earr[i].x) then ekx:=-1 else ekx:=1;
                  SpawnMissile(0.3,earr[i].x,earr[i].y,ekx,-1,0.01,0.01*(random(3)+1),round(earr[i].attack/10),0,false,false,'gauss');
                earr[i].aggr:=earr[i].aggr-1;
              end;
              if (sticker mod 20 = 0) then
              begin
                if (earr[i].state=1) and (earr[i].aggr=1) then
                begin
                  if (plr.x<earr[i].x) then ekx:=-1 else ekx:=1;
                  SpawnMissile(0.6,earr[i].x,earr[i].y,ekx,1,(random(200)+100)/20000,(random(200)+100)/20000,earr[i].attack,GLSphere1.Radius*2,true,True,'grenade');
                  earr[i].aggr:=earr[i].rectime; earr[i].state:=0;
                end;
                if (earr[i].aggr=0) and (earr[i].state=1) then
                  earr[i].state:=0;
                if earr[i].aggr>0 then
                  earr[i].aggr:=earr[i].aggr-1;
                if (random(earr[i].ac)<3) and (earr[i].state<>1) then
                begin
                  earr[i].state:=1;
                  earr[i].aggr:=earr[i].rectime;
                  DamageArea(1,'fx_0',earr[i].x,earr[i].y,(earr[i].size*1.5),round(earr[i].attack/5),false,'discharge');
                  //ShowMessage('Attack!');
                end;
              end;

            end;

          end;

          7:begin

            with earr[i] do
            begin

              //rolling cycles
              if aggr>0 then
                aggr:=aggr-1;
              if wcycle>0 then
                wcycle:=wcycle-1;

              //movement
              if (abs(x-plr.x)<bs*3.5) and (abs(x-plr.x)>bs*0.5) and (state<>1) and (state<>2) then
              begin
                state:=1;
                wcycle:=500;
                ix:=0.015;
              end;
              //stand on the ground
              if level[getcbl(x)].pit=false then
                y:=level[getcbl(x)].fh+size/2
              else
                y:=y;
              //move on x
              if ((state=1) or (state=2)) and
                 ((abs(x-plr.x)<bs*3.5) and (abs(x-plr.x)>bs*0.5)) then
              begin
                if plr.x<x then kx:=-1;
                if plr.x>x then kx:=1;
                x:=x+ix*kx;
              end;
              //switch move states
              if (state=1) and (wcycle=0) then
              begin
                wcycle:=500;
                state:=2;
              end;
              if (state=2) and (wcycle=0) then
              begin
                wcycle:=500;
                state:=1;
              end;
              //close combat hit
              if (abs(x-plr.x)<=bs*0.5) and (aggr<=round(rectime/2)) then
              begin
                state:=0;
              end;
              if (abs(x-plr.x)<=bs*0.5) and (aggr=0) then
              begin
                state:=4;
                aggr:=rectime;
                DamageArea(1,'fx_-1',x,y+size/2,size*2,round(attack/3),false,'hit');
              end;
              //shot from far
              if (abs(x-plr.x)>=bs*3.5) and (aggr<=round(rectime/2)) then
              begin
                state:=0;
              end;
              if (abs(x-plr.x)>=bs*3.5) and (aggr=0) then
              begin
                state:=3;
                aggr:=rectime;
                if plr.x<x then ekx:=-1;
                if plr.x>x then ekx:=1;
                SpawnMissile(0.3,earr[i].x,earr[i].y,ekx,0,0.01,0,round(earr[i].attack/2),0,false,false,'gauss');
              end;

            end;

            end; //<-end of 7


            8:begin

              if (earr[i].aggr=0) then
              begin
                DamageArea(1,'vamp_l',earr[i].x-earr[i].size/2,plr.ry,GLSphere1.Radius*4,round(earr[i].attack/4),false,'splash');
                earr[i].aggr:=earr[i].rectime*100;
              end;

              if earr[i].aggr>0 then earr[i].aggr:=earr[i].aggr-1;


              if earr[i].aggr mod 300 = 0 then
              begin
                //shooting grenades
                earr[i].wcycle:=earr[i].wcycle-1;
                if earr[i].wcycle<=0 then
                begin
                  earr[i].wcycle:=15;
                  if (plr.x<earr[i].x) then ekx:=-1 else ekx:=1;
                    SpawnMissile(0.6,earr[i].x,earr[i].y,ekx,1,(random(200)+100)/20000,(random(200)+100)/20000,round(earr[i].attack/4),GLSphere1.Radius*2,true,True,'grenade');
                end;
                //switching states
                earr[i].state:=earr[i].state+1;
                if earr[i].state>2 then earr[i].state:=0;
                //hitting nearby player
                if (abs((earr[i].x-plr.x))<round(bs*1.5)) and (earr[i].wcycle=1) then
                begin
                  DamageArea(1,'fx_-1',earr[i].x,earr[i].y,earr[i].size*2,round(earr[i].attack/3),false,'hit');
                end;
              end;

            end;



          end;  // <---end of CASE


        //end checking enemy types
      end;
    end;

    //processing missiles
    for i:=0 to maxmiss do
    begin
      with marr[i] do
      begin
        if marr[i].alive=true then
        begin
          marr[i].x:=marr[i].x+marr[i].spd*marr[i].kx;
          marr[i].y:=marr[i].y+abs(marr[i].spdy)*marr[i].ky;
          if grav=true then
          begin
            marr[i].spdy:=marr[i].spdy-0.00001;
            if marr[i].spdy>0 then ky:=1;
            if marr[i].spdy<=0 then ky:=-1;
          end;
          if (x<=(plr.x+(GLSphere1.Radius-0.4))) and (x>=(plr.x-(GLSphere1.Radius-0.4))) and
             (y<=(plr.y+GLSphere1.Radius+(GLSphere1.Radius-0.1))) and (y>=(plr.y+GLSphere1.Radius-(GLSphere1.Radius-0.1))) and
             (plr.shield=0) and (plr.invuln=false) then
          begin
            plr.hp:=plr.hp-dmg;
            alive:=false;
            showrs:=10;
            //GLLightSource1.ConstAttenuation:=0;
            //GLLightSource1.Diffuse.Red:=1;
            //GLLightSource1.Diffuse.Green:=0;
            //GLLightSource1.Diffuse.Blue:=0;
            //ShowMessage('Hit player!');
          end;
          if abs(marr[i].x-plr.x)>(bs*workdist) then
          begin
            marr[i].alive:=false;
           // ShowMessage('Missile despawn: too far from player!');
          end;
          if (marr[i].x<-10) or (marr[i].x>(bs*lvllength+bs+10)) then
          begin
            marr[i].alive:=false;
           // ShowMessage('Missile despawn: outta map!');
          end;
          if (marr[i].y<level[GetCBL(marr[i].x)].fh) and (marr[i].grav=true) then
          begin
            DamageArea(1,'boom',marr[i].x,y+marr[i].brad,marr[i].brad*2,marr[i].dmg,true,'blow');
            marr[i].alive:=false;
          end;
        end
        else
        begin

        end;
      end;
    end;
    handlemissiles;

    for i:=0 to 100 do
    begin
      if bonuscb=true then
        begin
          barr[i].comeback:=100;
        end;
      if (barr[i].alive=true) then
      if (abs(plr.x-barr[i].x)<GLSphere1.Radius) and
         (abs((plr.y+GLSphere1.Radius)-barr[i].y)<GLSphere1.Radius) then
      begin
        case barr[i].tp of
        0:begin
            barr[i].alive:=false;
            plr.hp:=plr.hp+20+random(plr.intelligence);
            if plr.hp>plr.hpmax then plr.hp:=plr.hpmax;
          end;
        1:begin
            barr[i].alive:=false;
            plr.eng:=plr.eng+20+random(plr.intelligence);
            if plr.eng>plr.engmax then plr.eng:=plr.engmax;
          end;
        end;

      end;
    end;
end;

procedure TForm1.handlemissiles;
var i,j:integer;
begin
  //AddRL('Processing effects. Eproc = '+booltostr(eproc));
  for i:=0 to maxmiss do
  begin
    if marr[i].alive=true then
    begin
      for j:=0 to maxmiss do
      begin
        if (marr[j].alive=true) and
           (i<>j) and
           (abs(marr[i].x-marr[j].x)<0.1) and
           (abs(marr[i].y-marr[j].y)<0.1) then
        begin
          marr[j].alive:=false;
        end;
      end;
      try
        missiles[i].Position.X:=(marr[i].x);
        missiles[i].Position.Y:=(marr[i].y);
        missiles[i].Position.Z:=(GLSphere1.Position.Z);
        missiles[i].Width:=marr[i].d*2.5;
        missiles[i].Height:=marr[i].d*2.5;
      except
        //FreeAndNil(missiles[i]);
        //missiles[i].CreateAsChild(gmbase);
        //missiles[i].Stacks:=6;
        //missiles[i].Slices:=6;
        //missiles[i].Radius:=0.3;
        //ShowMessage('x='+floattostr(marr[i].x)+'; y='+floattostr(marr[i].y));
      end;
    end
    else
    begin
      try if missiles[i].Visible=true then
        missiles[i].Visible:=false; except end;
    end;
  end;
end;


procedure TForm1.monitorblockvisibility;
var i:integer;
begin
  AddRL('Monitor block visibility');
  for i:=0 to lvllength do
  begin
    if (abs(i-cbl)>workdist) and (floor[i].Visible=true) then
    begin
      try
        floor[i].Visible:=false;
        ceil[i].Visible:=false;
        flplane[i].Visible:=false;
        bgtile[i].Visible:=false;
        cltile[i].Visible:=false;
        fltile[i].Visible:=false;
        if level[i].crusher=true then
          crushercyl[i].Visible:=false;
        if ppl[i]=true then
          pitplanel[i].Visible:=false;
        if ppr[i]=true then
          pitplaner[i].Visible:=false;
      except
      end;
    end;
    if (abs(i-cbl)<=workdist) and (floor[i].Visible=false) then
    begin
      try
        floor[i].Visible:=true;
        if lg_hasceil=true then
          ceil[i].Visible:=true
        else
          ceil[i].Visible:=false;
        flplane[i].Visible:=true;
        bgtile[i].Visible:=true;
        if lg_hasceil=true then
          cltile[i].Visible:=true
        else
          cltile[i].Visible:=true;
        fltile[i].Visible:=true;
        if level[i].crusher=true then
          crushercyl[i].Visible:=true;
        if ppl[i]=true then
          pitplanel[i].Visible:=true;
        if ppr[i]=true then
          pitplaner[i].Visible:=true;
      except
      end;
    end
  end;

  //processing enemy visibility
  for i:=0 to 100 do
  begin
    if earr[i].alive=true then
    if abs(esprites[i].Position.X-plr.x)>(workdist*bs) then
    begin
      try
        esprites[i].Visible:=false;
      except end;
    end
    else
    begin
      try
        esprites[i].Visible:=true;
      except end;
    end;
  end;

  //processing other objects visibility
  for i:=0 to 100 do
  begin
    if barr[i].alive=true then
    if abs(bonsprites[i].Position.X-plr.x)>(workdist*bs) then
    begin
      try
        bonsprites[i].Visible:=false;
      except end;
    end
    else
    begin
      try
        bonsprites[i].Visible:=true;
      except end;
    end;

    if darr[i].tp<>-1 then
    if abs(decsprites[i].Position.X-plr.x)<=(workdist*bs) then
    begin
      try
        decsprites[i].Visible:=true;
      except end;
    end
    else
    begin
      try
        decsprites[i].Visible:=false;
      except end;
    end;

  end;
end;

procedure TForm1.ClenupEffectsData;
var i:integer;
begin
  for i:=0 to 1000 do
  begin
    with fxs[i] do
    begin
      alive:=false;
      aframe:=0;
      spriten:='';
    end;
  end;
end;

procedure TForm1.DropEffect(x,y,size:real;spr:string);
var ii:integer; fn:string;
begin
  if eproc=false then  begin
  AddRL('Dropping effect "'+spr+'"');
  try
    //ShowMessage('starting effect drop');
    //drops an effect at position
    ii:=-1;
    repeat
      ii:=ii+1;
    until (ii>(maxeffs-1)) or (fxs[ii].alive=false);
    //ShowMessage('ii='+inttostr(ii));


    if ii<maxeffs then
    begin
      fxs[ii].alive:=true;
      fxs[ii].spriten:=spr;
      fxs[ii].aframe:=9;
      fxs[ii].x:=x;
      fxs[ii].y:=y;
      fxs[ii].w:=size;
      fxs[ii].h:=size;
      {try
        effects[ii].Visible:=true;
        TGLSprite(effects[ii]).Material.MaterialLibrary:=fxmatlib;
      except end;  }
    end
    else
    begin
      AddRL('Effect drop failure');
    end;
    //ShowMessage('effect dropped');
    //ProcessEffects;
  except
    AddRL('Effect drop failure');
  end;


  end;
end;

procedure TForm1.ProcessEffects;
var i:integer;
    fn,mn:string;
begin
  //effects graphics
  AddRL('Processing effects. Eproc = '+booltostr(eproc));
  if (eproc=false) and (cadencerhange=false) then
  begin
    eproc:=true;
    for i:=0 to maxeffs do
    begin
      //previous handling
      if (fxs[i].alive=false) then effects[i].Visible:=false;
      if fxs[i].alive=true then
      begin
        effects[i].Visible:=true;
        if fxs[i].aframe>10 then fxs[i].aframe:=9;
        if fxs[i].aframe<0 then fxs[i].aframe:=0;
        if (fxs[i].aframe=0) then
        begin
          fxs[i].alive:=false;
        end;

        //handling sprite graphics

        //fn:=gameexe+'\esprites\'+fxs[i].spriten+'_'+inttostr(fxs[i].aframe)+'.tga';
        try
          effects[i].Width:=fxs[i].w;
          effects[i].height:=fxs[i].h;
          effects[i].Position.X:=fxs[i].x;
          effects[i].Position.Y:=fxs[i].y;
          effects[i].Position.Z:=0.1;
          effects[i].Visible:=true;
          mn:=fxs[i].spriten+'_'+inttostr(fxs[i].aframe);
          TGLSprite(effects[i]).Material.LibMaterialName:=mn;
          with fxmatlib.LibMaterialByName(mn).Material do
          begin
            FrontProperties.Diffuse.Alpha:=(abs(fxs[i].aframe))/10;
          end;
        except
          //FillMLibraries;
        end;
        //ShowMessage('Counting frames...');
        if (fxs[i].aframe>0) then
          fxs[i].aframe:=fxs[i].aframe-1;
      end;
    end;
  end
  else
  begin

  end;
  AddRL('Processing effects done!');
  eproc:=false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i:integer;
    fn:string;
begin
 { //Show


  Form1.Caption:='Gene Princess 0.1; state='+inttostr(plr.state)+'; stick='+inttostr(form1.sticker)+'; x='+floattostr(plr.x)+'; y='+floattostr(plr.y);
  Form1.Caption:=Form1.Caption+'; cbl='+inttostr(cbl)+'; fh='+inttostr(level[cbl].fh);
  Form1.Caption:=Form1.Caption+'; ix='+floattostr(plr.ix)+'; iy='+floattostr(plr.iy);
  Form1.Caption:=Form1.Caption+'; kx='+floattostr(plr.kx)+'; ky='+floattostr(plr.ky);
  Form1.Caption:=Form1.Caption+'; dx='+floattostr((plr.ix/plr.spd)*plr.kx);

  //light control
  if GLLightSource1.ConstAttenuation<1 then
  begin
    GLLightSource1.ConstAttenuation:=GLLightSource1.ConstAttenuation+0.2;
  end;

  //animation control
  plr.aframe:=plr.aframe-1;
  if plr.aframe<0 then plr.aframe:=9;
  AssignPlayerSprite;
  if lgen=false then
  begin
    processenemysprites;
    processeffects;
    monitorblockvisibility;
    processgui;
  end;}
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
{//stick management
  form1.sticker:=form1.sticker+1;
  if (form1.sticker>=999) then
  begin
    form1.sticker:=0;
    //ShowMessage('stick!');
  end;
  //end stick management :)
  if form1.sticker=0 then
  begin
    //ShowMessage('stike zero');
  end;}
end;

procedure TForm1.ResetGame;
begin
  AddRL('Reset game');
  with plr do
  begin
    x:=1;
    y:=0;
    state:=0;
    spd:=400;
    lvl:=1;
    plevel:=1;
    hpmax:=100;
    hp:=100;
    speed:=10;
    intelligence:=10;
    strength:=10;
    speed:=10;
    xp:=0;
    xpreq:=100;
    eng:=1000;
    lives:=4;
  end;
  levno:=0;
  points:=0;
  lvllength:=20;
  rg:=true;
  if gamemode=0 then
    SwitchLevel(-1)
  else
  begin
    //SwitchLevel(lorder[levno-1]);
    LoadNextLevel;
  end;
end;

procedure TForm1.BuildMainMenu;
var i:integer; fn:string;
begin
  //creates a main menu items
  //AddRL('Making main menu...');
  try
    FreeAndNil(gamelogo);
    FreeAndNil(spacebar);
    FreeAndNil(mmbg);
    FreeAndNil(mmhelpbg);
    FreeAndNil(gamemodeind);
    FreeAndNil(difficulty);
    FreeAndNil(exitb);
  except
  end;
  gamelogo:=TGLHUDSprite(gmmainmenu.AddNewChild(TGLHUDSprite));
  spacebar:=TGLHUDSprite(gmmainmenu.AddNewChild(TGLHUDSprite));
  gamemodeind:=TGLHUDSprite(gmmainmenu.AddNewChild(TGLHUDSprite));
  difficulty:=TGLHUDSprite(gmmainmenu.AddNewChild(TGLHUDSprite));
  exitb:=TGLHUDSprite(gmmainmenu.AddNewChild(TGLHUDSprite));

  mmbg:=TGLSprite.CreateAsChild(gmmainmenub);
  mmhelpbg:=TGLSprite.CreateAsChild(gmmainmenub);
  with gamelogo do
  begin
    fn:=gameexe+'\textures\gplogo.tga';
    with gamelogo.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=300;
    Height:=300;
    Position.X:=5+gamelogo.Width/2;
    Position.Y:=5+gamelogo.Height/2;
  end;
  with spacebar do
  begin
    fn:=gameexe+'\textures\spacebar.tga';
    with spacebar.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmModulate;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=150;
    Height:=30;
    Position.X:=MSData.Width/2;
    Position.Y:=MSData.Height-Height;
  end;
  with mmbg do
  begin
    fn:=gameexe+'\textures\mm_bg_img.tga';
    with mmbg.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmDecal;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=bs*8;
    Height:=bs*3;
    Position.X:=0;
    Position.Y:=0;
    Position.Z:=-1;
  end;
  with mmhelpbg do
  begin
    fn:=gameexe+'\textures\mm_help_img.tga';
    with mmhelpbg.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmDecal;
      FrontProperties.Diffuse.Red:=1;
      FrontProperties.Diffuse.Green:=1;
      FrontProperties.Diffuse.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=bs*8;
    Height:=bs*3;
    Position.X:=0;
    Position.Y:=0;
    Position.Z:=-1;
    visible:=false;
  end;
  with gamemodeind do
  begin
    fn:=gameexe+'\textures\m2.tga';
    with gamemodeind.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmDecal;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=60;
    Height:=60;
    //Position.X:=0;
    //Position.Y:=0;
    //Position.Z:=-1;
    visible:=true;
  end;
  with difficulty do
  begin
    fn:=gameexe+'\textures\m4.tga';
    with difficulty.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmDecal;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=60;
    Height:=60;
    //Position.X:=0;
    //Position.Y:=0;
    //Position.Z:=-1;
    visible:=true;
  end;
  with exitb do
  begin
    fn:=gameexe+'\textures\m1.tga';
    with exitb.Material do
    begin
      BlendingMode:= bmTransparency;
      Texture.Image.LoadFromFile(fn);
      Texture.Disabled:= false;
      Texture.TextureMode:=tmDecal;
      FrontProperties.Emission.Red:=1;
      FrontProperties.Emission.Green:=1;
      FrontProperties.Emission.Blue:=1;
      FrontProperties.Diffuse.Alpha:=1;
    end;
    Width:=60;
    Height:=60;
    //Position.X:=0;
    //Position.Y:=0;
    //Position.Z:=-1;
    visible:=true;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  GLCadencer1.Enabled:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
 var fn:string;
    i:integer;
begin
  //datacleanup;
  //AddRL('Starting Game...');
  Randomize;
  sticker:=1;
  gameexe:=ExtractFileDir(Application.ExeName);
  LoadConfig;
  BuildMainMenu;
  FillMLibraries;
  GetLevelOrder;
  sh:=Form1.ClientHeight;
  //basic player settings
  for i:=0 to maxmiss do
  begin
    marr[i].alive:=false;
  end;
  GetComMan(0);
  ShowComic(0,0);
  gamestate:=0;
  gamemode:=1;
  hardcore:=false;
  //ResetGame;
  //menuholder:=TGLDummyCube.CreateAsChild(GLScene1.);

  musicname:='mmenu';
  RunCurrentMusic;

  GLWindowsBitmapFont1.Ranges[0].StartASCII:=#0;
  GLWindowsBitmapFont1.Ranges[0].StopASCII:=#255;
  //LoadSounds;
end;

procedure Tform1.managewalking(walkdir:integer);
begin
  {with plr do begin
  if walkdir=-1 then
  begin

  end;
  if walkdir=1 then
  begin

    //if dblright=0 then dblright:=5;
    if dblright>0 then ix:=20;
  end;
  if walkdir=0 then
  begin

    //if dblleft=0 then dblleft:=5;
    if dblleft>0 then ix:=20;
  end; end;    }
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var fk:integer;
begin
  //----GAMEMODE----
  if (gamestate=1) and (plr.morph=0) and (plr.pushed=0) and (comicmode=false) then
  begin
    with plr do
    begin
      if key=VK_LEFT then
      begin
        if state=0 then
        begin
          face:=1;
          state:=5;
          ix:=5+speed/10;
          kx:=-1;
          if (ssAlt in shift) and (eng>20) then
          begin
            ix:=15+speed/5;
            eng:=eng-20;
          end;
        end;
        if state=1 then
        begin
          face:=1;
          ix:=5+speed/10;
          kx:=-1;
        end;
      end;
      if (key=VK_DOWN) then
      begin
        if (state=1) and (ky=-1) and (eng>20) then
        begin
         eng:=eng-20;
          iy:=10+(strength/10);
          if lvl>0 then
          begin
            hawkfall:=true;
          end;
        end;
      end;
      if key=VK_RIGHT then
      begin
       if state=0 then
       begin
         face:=0;
         state:=6;
         ix:=5+speed/10;
         kx:=1;
         if (ssAlt in shift) and (eng>20) then
         begin
           ix:=15+speed/5;
           eng:=eng-20;
         end;
        end;
        if state=1 then
        begin
          face:=0;
          ix:=5+speed/10;
          kx:=1;
        end;
      end;
      if key=VK_SPACE then
      begin
        if (state<>1) then
        begin
          state:=1;
          iy:=5+(strength/10);
          ky:=1;
          if ondeco=true then y:=y+0.01;
          if musicon=true then
            PlaySound(PWideChar(gameexe+'\sound\hop.wav'),0,SND_ASYNC);

        end
        else
        begin
          if (lvl>2) and (eng>=10) then
          begin
            state:=1;
            eng:=eng-10;
            iy:=5+(strength/10);
            ky:=1;
            if ondeco=true then y:=y+0.01;
            if musicon=true then
              PlaySound(PWideChar(gameexe+'\sound\hop.wav'),0,SND_ASYNC);
          end;
        end;
      end;


    end;
  end;


  //----MENUMODE----

  if (gamestate=0) then
  begin
    if (key=VK_NUMPAD1) and (showhelp=false) and (comicmode=false) then
    begin
      if gamemode=0 then gamemode:=1 else gamemode:=0;
      if gamemode=0 then ShowAtBottom('Random mode activated');
      if gamemode=1 then ShowAtBottom('Story mode activated');
    end;
    if (key=VK_NUMPAD2) and (showhelp=false) and (comicmode=false) then
    begin
      if hardcore=false then hardcore:=true else hardcore:=false;
      if hardcore=false then ShowAtBottom('Hardcore mode deactivated');
      if hardcore=true then ShowAtBottom('Hardcore mode activated');
    end;

    if Key=VK_SPACE then
    begin

      if (comicmode=false) then
      begin

      if showhelp=false then
      begin
        if cmenuitem=0 then
        begin
          gamestate:=1;
          ResetGame;
          musicname:=lg_music;
          if musicon=true then
            RunCurrentMusic;
        end;
        if cmenuitem=1 then
        begin
          if hardcore=false then hardcore:=true else hardcore:=false;
          if hardcore=false then ShowAtBottom('Hardcore mode deactivated');
          if hardcore=true then ShowAtBottom('Hardcore mode activated');
        end;
        if cmenuitem=2 then
        begin
          Halt(0);
        end;
      end
      else
      begin
        showhelp:=false;
        if rg=true then
        begin
          gamestate:=1;
        end;
      end;

      end
      else
      begin
        comicmode:=false;
        if rg=true then
          gamestate:=1
        else
          gamestate:=0;
      end;

    end;
  end;
end;

procedure TForm1.DoFullScreen(dofs:boolean);
begin
  if dofs=true then
    begin
      Form1.BorderStyle:=bsNone;
      Form1.Align:=alClient;
      Form1.FormStyle:=fsStayOnTop;
      fscr:=true;
    end
    else
    begin
      Form1.BorderStyle:=bsSizeable;
      Form1.FormStyle:=fsNormal;
      Form1.Align:=alNone;
      Form1.Width:=1035;
      Form1.Height:=654;
      Form1.Left:=round(Screen.Width/2-Form1.Width/2);
      Form1.Top:=round(Screen.Height/2-Form1.Height/2);
      fscr:=false;
    end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var fk:integer;
    datext:string;
begin
  if (Key=VK_ESCAPE) and (rg=true) then
  begin
    if gamestate=0 then
      gamestate:=1
    else
      gamestate:=0;
  end;
  if (gamestate=0) and (comicmode=false) and (showhelp=false) then
  begin

    if KEY=VK_LEFT then
    begin
      cmenuitem:=cmenuitem-1;
      if cmenuitem<0 then cmenuitem:=2;
      case cmenuitem of
      0:begin
          ShowAtBottom('New game (UP/DOWN to pick mode)');
        end;
      1:begin
          ShowAtBottom('Difficulty setting (UP/DOWN to pick mode)');
        end;
      2:begin
          ShowAtBottom('Quit');
        end;
      end;
    end;
    if KEY=VK_RIGHT then
    begin
      cmenuitem:=cmenuitem+1;
      if cmenuitem>2 then cmenuitem:=0;
      case cmenuitem of
      0:begin
          ShowAtBottom('New game (UP/DOWN to pick mode)');
        end;
      1:begin
          ShowAtBottom('Difficulty setting (UP/DOWN to pick mode)');
        end;
      2:begin
          ShowAtBottom('Quit');
        end;
      end;
    end;
    if (KEY=VK_UP) or (Key=VK_DOWN) then
    begin
      if cmenuitem=0 then
      begin
        if gamemode=1 then
        begin
          gamemode:=0;
          ShowAtBottom('Random mode selected');
        end
        else
        begin
          gamemode:=1;
          ShowAtBottom('Story mode selected');
        end;
      end;
      if cmenuitem=1 then
      begin
        if hardcore=true then
        begin
          hardcore:=false;
          ShowAtBottom('Hardcore mode deactivated');
        end
        else
        begin
          hardcore:=true;
          ShowAtBottom('Hardcore mode activated');
        end;
      end;
    end;
  end;

  if key=VK_F4 then Form3.Show;
  if key=VK_F5 then Form4.Show;

  if (Key=VK_F10) then
  begin
    if fscr=false then
      DoFullScreen(true)
    else
      DoFullScreen(false);

    {if fscr=false then
    begin
      Form := TForm.Create(nil);
      Form.Show;
      Form1.Visible:=false;
      GLFullScreenViewer1.Cursor:=crNone;
      GLFullScreenViewer1.Form := Form;
      GLFullScreenViewer1.UseCurrentResolution;
      //GLFullScreenViewer1.Width:=800;
      //GLFullScreenViewer1.Height:=600;
      GLFullScreenViewer1.Active:=True;
      fscr:=true;
    end
    else
    begin
      Form1.Visible:=true;
      GLFullScreenViewer1.Cursor:=crDefault;
      GLFullScreenViewer1.Active:=True;
      Form.Free;
      fscr:=false;
    end;
    if fscr=true and GLFullScreenViewer1.Active=false then
    begin
      GLFullScreenViewer1.ReActivate;
    end;    }
  end
  else
  begin
    //GLFullScreenViewer1.Active:=false;
    //fscr:=false;
  end;
  if (key=VK_F1) and (comicmode=false) then
  begin
    BuildMainMenu;
    gamestate:=0;
    showhelp:=true;

  end;
  if key=VK_F2 then
  begin
    if musicon=true then
    begin
      musicon:=false;
      MediaPlayer1.Stop;
    end
    else
    begin
      musicon:=true;
      RunCurrentMusic;
    end;
  end;

  if (gamestate=1) and (plr.morph=0) and (plr.pushed=0) and (comicmode=false) and (lgen=false) then
  begin

    //on release key
    if Key=VK_F7 then
    begin
     plr.xp:=plr.xpreq+10;
     plr.hp:=plr.hpmax;
     plr.eng:=plr.engmax;
    end;

    if Key=VK_F11 then
    begin
      ResetGame;
    end;
    if Key=VK_F12 then
    begin
      SwitchLevel(-1);
      //BuildLevelGeometry;
      KillPlayer;
      //lgen:=false;
    end;
    with plr do
    begin
      if (key=VK_END) and (eng=engmax) and (lvl>=5) then
      begin
        eng:=0;
        DamageArea(0,'flesh',x,y+GLSphere1.Radius*2,GLSphere1.Radius*14,round(plr.strength*10),false,'splash');
      end;
      if (Key=VK_UP) and (ssCtrl in shift) and ((eng>=10-(intelligence-10))) then
      begin
        state:=2;
        hitrec:=hitrecbase;
        DamageArea(0,'fx_-1',x,y+(GLSphere1.Radius*3),GLSphere1.Radius+1,round(plr.strength*sqrt(plr.plevel)),false,'hit');
        plr.hitstate:=5;
        if intelligence<20 then
          eng:=eng-10-(intelligence-10);
      end;

      if (Key=VK_TAB) and (plr.hitrec=0) and (eng>=500/intelligence) and
         (plr.lvl>3)then
      begin
        if face=0 then
        begin
          fk:=1;
          datext:='vamp_r';
          DamageArea(0,datext,rx+GLSphere1.Radius*1.5*(fk),ry+2,GLSphere1.Radius*3,plr.strength*3,false,'splash');
        end
        else
        begin
          fk:=-1;
          datext:='vamp_l';
          DamageArea(0,datext,rx+GLSphere1.Radius*1.5*(fk),ry+2,GLSphere1.Radius*3,plr.strength*3,false,'splash');
        end;
        plr.hp:=plr.hp+tothpdam;
        if plr.hp>hpmax then hp:=hpmax;
        plr.eng:=plr.eng-round(500/intelligence);
      end;

      if (key=VK_CONTROL) and (state<>2) and (plr.hitrec=0) then
      begin
        state:=2;
        hitrec:=hitrecbase;
        if face=0 then fk:=1;
        if face=1 then fk:=-1;
        DamageArea(0,'fx_-1',x+GLSphere1.Radius*(fk),y+(GLSphere1.Radius),GLSphere1.Radius+1,plr.strength,false,'hit');
        plr.hitstate:=5;
        if earr[100].alive=true then hitrec:=round(hitrecbase/2);
      end;
      if (key=VK_LEFT) or (key=VK_Right) then
      begin
        state:=0;
        ix:=0;
        kx:=0;
      end;
      if (key=VK_LEFT) then
      begin
        dblleft:=5;
      end;
      if (key=VK_Right) then
      begin
        dblright:=5
      end;
      if Key=VK_F1 then
      begin
       with plr do
       ShowMessage(
        'State='+inttostr(state)+'; '+
        'LVL='+inttostr(lvl)+'; '+
        'spd='+floattostr(spd)+'; '+
        '');
      end;
      if (key=VK_SHIFT) and (eng>=30) and (lvl>1) then
      begin
        //ShowMessage('shield on');
        shield:=70;
        eng:=eng-30;
      end;
      if wannalevelup=true then
      begin
        if key=VK_NUMPAD1 then
        begin
          wannalevelup:=false;
          strength:=strength+1;
          bitex:=gameexe+'\textures\plstr.tga';
          ShowAtBottom('Strength increased');
          showbi:=30;
          //hp:=hpmax;
        end;
        if key=VK_NUMPAD2 then
        begin
          wannalevelup:=false;
          speed:=speed+1;
          bitex:=gameexe+'\textures\plspd.tga';
          ShowAtBottom('Speed increased');
          showbi:=30;
        end;
        if key=VK_NUMPAD3 then
        begin
          wannalevelup:=false;
          intelligence:=intelligence+1;
          bitex:=gameexe+'\textures\plint.tga';
          ShowAtBottom('Intelligence increased');
          showbi:=30;
        end;

      end;
    end;
  end;

  if gamestate=0 then
  begin
    if comicmode=true then
    begin
      if Key=VK_RIGHT then
      begin
        if (currpg<(pagesno-1)) then
        begin
          currpg:=currpg+1;
          ShowComic(ccomicid,currpg);
        end;
      end;
      if Key=VK_LEFT then
      begin
        if (currpg>0) then
        begin
          currpg:=currpg-1;
          ShowComic(ccomicid,currpg);
        end;
      end;

    end;
  end;
end;

procedure TForm1.LoadNextLevel;
begin
  //datacleanup;
  AddRL('Load Next Level...');
  if levno<>1 then
    points:=points+100;
  levno:=levno+1;
  cbl:=0;
  plr.x:=round(bs/2);
  if gamemode=0 then
  begin
    SwitchLevel(-1);
  end;
  //story mode has more levels
  //currpg:=0;
  //repeat

  //until (comicmode=false);
  //repeat
  //  Application.ProcessMessages;
  //until (comicmode=false);
  if (gamemode=1) and (levno<=ltot) then
  begin
    gamestate:=0;
    GetComMan(levno);
    //ShowMessage();
    ShowComic(levno,0);
    SwitchLevel(lorder[levno-1]);
  end;
  //storymode has no more levels

  if (gamemode=1) and (levno>ltot) then
  begin
    ResetGame;
    gamestate:=0;
    GetComMan(7);
    ShowComic(7,0);
    SwitchLevel(lorder[levno-1]);
  end;
  plr.y:=level[cbl].fh;
  plr.kx:=0;
  plr.state:=0;
  plr.ky:=0;
  plr.ix:=0;

end;

procedure TForm1.HandleBottomText;
begin
  if (bottomtext.Text<>ctextmsg) then
    bottomtext.Text:=ctextmsg;
  bottomtext.Position.X:=GLSceneViewer1.Width/2+150;
  if bottomtext.Position.Y<GLSceneViewer1.Height+30 then
  begin
    bottomtext.Position.Y:=bottomtext.Position.Y+0.005;
  end;
end;

procedure TForm1.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
  if eproc=false then begin
  cadencerhange:=false;
  stick2:=stick2+1;
  if stick2>998 then stick2:=0;
  if stick2 mod 200 = 0 then
  begin
    Cadencerrun;
    Cadencerrun2;
    if lgen=false then
    begin
      AssignPlayerSprite;
      processenemysprites;
      processeffects;
      monitorblockvisibility;
      //handlemissiles;
      processgui;
    end;
  end;

  with MSDATA do
  begin
    width:=GLSceneViewer1.Width;
    height:=GLSceneViewer1.Height;
  end;

  if gamestate=1 then
  begin
    if plr.spd<>400 then plr.spd:=400;
    if LGen=false then
      RecalcPositions;
    if (cbl=lvllength) and (earr[100].alive=false) then
    begin
      lvllength:=lvllength+30;
      if lvllength>100 then lvllength:=100;
      if gamemode=1 then
      begin
        plr.lvl:=plr.lvl+1;
        //plr.morph:=10;
        plr.ix:=0;
        LoadNextLevel;
      end
      else
        LoadNextLevel;
    end;
  end;

  if gamestate=0 then
  begin
    Camera.SceneScale:=1;
    Camera.Position.X:=0;
    Camera.Position.Y:=0;
    Camera.Position.Z:=30;
    spacebar.Position.X:=MSData.Width/2;
    spacebar.Position.Y:=MSData.Height-spacebar.Height;
    mmbg.Width:=bs*((screen.width/100)*0.85)*(MSData.Width/Screen.Width);
    mmbg.Height:=bs*((screen.Height/100)*0.85)*(MSData.Height/Screen.Height);
    mmhelpbg.Width:=bs*((screen.Width/100)*0.85)*(MSData.Width/Screen.Width);
    mmhelpbg.Height:=bs*((screen.Height/100)*0.85)*(MSData.Height/Screen.Height);
  end; end
  else
  begin
    cadencerhange:=true;
    AddRL('Cadencer hange');
  end;

  //bottom text management
  HandleBottomText;
  //done botttom text mgmt

end;


procedure TForm1.Cadencerrun;
var i:integer;
    fn:string;
begin

  If Form4.Memo1.Lines.Count>5000 then Form4.Memo1.Clear;
  AddRL('Cadencerrun');
  Form1.Caption:='Gene Princess 0.5';
  if form4.Visible=true then
    Form4.Memo2.Text:='state='+inttostr(plr.state)
    +'; stick='+inttostr(sticker)+'; stick2='+inttostr(stick2)
    +'; x='+floattostr(plr.x)+'; y='+floattostr(plr.y)
    +'; cbl='+inttostr(cbl)+'; fh='+inttostr(level[cbl].fh)
    +'; ix='+floattostr(plr.ix)+'; iy='+floattostr(plr.iy)
    +'; kx='+floattostr(plr.kx)+'; ky='+floattostr(plr.ky)
    +'; dx='+floattostr((plr.ix/plr.spd)*plr.kx)+'; eproc = '+booltostr(eproc);

  for i:=0 to 1000 do
  begin
    if (barr[i].alive=false) and (bonuscb=true) and (barr[i].tp<>-1) then
    begin
      with barr[i] do
      begin
        if (comeback>0) then
          comeback:=comeback-1;
        if (comeback=0) then alive:=true;
      end;
    end;
  end;

  //light control
  if GLLightSource1.ConstAttenuation<1 then
  begin
    GLLightSource1.ConstAttenuation:=GLLightSource1.ConstAttenuation+0.2;
  end
  else
  begin
    GLLightSource1.Diffuse.Red:=1;
    GLLightSource1.Diffuse.Green:=1;
    GLLightSource1.Diffuse.Blue:=1;
  end;

  //animation control
  plr.paframe:=plr.paframe-1;
  if plr.paframe<0 then plr.paframe:=9;

end;

procedure TForm1.GLCadencer2Progress(Sender: TObject; const deltaTime,
  newTime: Double);
var i:integer;
    fn:string;
begin


end;

procedure TForm1.Cadencerrun2;
var fn:string;
begin
//stick management
  AddRL('Cadencerrun 2');
  if MediaPlayer1.Position=MediaPlayer1.Length then
  begin
    if gamestate=1 then
      musicname:=lg_music;
    if gamestate=0 then
      musicname:='mmenu';
    RunCurrentMusic;
  end;
  if (gamestate=1) then
  begin
    if gmbase.Visible=false then
    begin
      gmmainmenu.Visible:=false;
      gmmainmenub.Visible:=false;
      gmbase.Visible:=true;
      gmuibase.Visible:=true;
      gmuibase2.Visible:=true;
      pointstext.Visible:=true;

    end;
    //Cadencerrun;
    sticker:=sticker+1;
    if (sticker>998) then
    begin
      sticker:=0;
      //ShowMessage('stick!');
    end;

    //processing TIMELIMITS

    if timeleft>0 then
    begin
      timeleft:=timeleft-1;
    end
    else
    begin
      //if earr[100].alive=true then
        SwitchLevel(levelset);
      //else
      //  SwitchLevel(-1);
      KillPlayer;
      plr.xp:=0;
      timeleft:=timetot;
    end;

    //doing -1 to all animation/display controllers



    if showrs>0 then showrs:=showrs-1;
    if plr.hitrec>0 then
      plr.hitrec:=plr.hitrec-1;
    if plr.foix>0 then
    begin
      plr.foix:=plr.foix-1;
      if plr.foix=0 then plr.ix:=0;
      if plr.foix<>0 then
      begin
        plr.kx:=plr.kxtf;
        plr.ix:=plr.ixtf;
      end;
    end;
    if plr.shield>0 then
      plr.shield:=plr.shield-1;

    if plr.pushed>0 then
    begin
      plr.pushed:=plr.pushed-1;
      if plr.pushed=0 then
      begin
        plr.kx:=0;
        plr.ix:=0;
      end;
    end;
    if dblleft>0 then
      dblleft:=dblleft-1;
    if dblright>0 then
      dblright:=dblright-1;
    //if plr.iy>5 then plr.iy:=plr.iy-2;

    if plr.hitstate>0 then
      plr.hitstate:=plr.hitstate-1;
    if showbi>0 then
      showbi:=showbi-1;
    if (plr.morph>0) and (sticker mod 3 = 0) then
      plr.morph:=plr.morph-1;
    //end stick management :)
    if sticker=0 then
    begin
      //ShowMessage('stike zero');
    end;
  end;
  if gamestate=0 then
  begin
    if gmmainmenu.Visible=false then
    begin
      gmmainmenu.Visible:=true;
      gmmainmenub.Visible:=true;
      gmbase.Visible:=false;
      gmuibase.Visible:=false;
      gmuibase2.Visible:=false;
      pointstext.Visible:=false;
    end;
    if showhelp=true then
    begin
      mmbg.Visible:=false;
      mmhelpbg.Visible:=true;
      gamelogo.Visible:=false;
      gamemodeind.Visible:=false;
      exitb.Visible:=false;
      difficulty.Visible:=False;
    end
    else
    begin
      mmbg.Visible:=true;
      mmhelpbg.Visible:=false;
      gamelogo.Visible:=true;
      gamemodeind.Visible:=true;
      exitb.Visible:=true;
      difficulty.Visible:=true;
    end;
    if (comicmode=true) and (showhelp=false) then
    begin

      mmbg.Visible:=false;
      mmhelpbg.Visible:=true;
      gamelogo.Visible:=false;
      spacebar.Visible:=false;
      gamemodeind.Visible:=false;
      exitb.Visible:=false;
      difficulty.Visible:=False;
    end;
    if (comicmode=false) and (showhelp=false) then
    begin
      mmbg.Visible:=true;
      mmhelpbg.Visible:=false;
      gamelogo.Visible:=true;
      spacebar.Visible:=true;
      gamemodeind.Visible:=true;
      exitb.Visible:=true;
      difficulty.Visible:=true;
    end;
    if comicmode=true then
    begin
      if turnstate>0 then turnstate:=turnstate-1;
      if (turnstate=0) and (currpg<>(pagesno-1)) then
      begin
        ShowComic(ccomicid,currpg+1);
      end;
      if (turnstate=0) and (autoclose=true) and (currpg=(pagesno-1)) then
      begin
        if rg=false then
          gamestate:=0
        else
          gamestate:=1;
        comicmode:=false;
      end;
    end;
    //processing menu items
    with gamemodeind do
    begin
      if gamemode=0 then
        fn:=gameexe+'\textures\m3.tga'
      else
        fn:=gameexe+'\textures\m2.tga';
      with gamemodeind.Material do
      begin
        Texture.Image.LoadFromFile(fn);
        Texture.Disabled:= false;
        Texture.TextureMode:=tmModulate;
      end;
      if cmenuitem=0 then
      begin
        Width:=90;
        Height:=90;
      end
      else
      begin
        Width:=60;
        Height:=60;
      end;
      Position.X:=GLSceneViewer1.Width/2-90;
      Position.Y:=GLSceneViewer1.Height/2;
    end;
    with difficulty do
    begin
      if hardcore=false then
        fn:=gameexe+'\textures\m4.tga'
      else
        fn:=gameexe+'\textures\m5.tga';
      with difficulty.Material do
      begin
        Texture.Image.LoadFromFile(fn);
        Texture.Disabled:= false;
        Texture.TextureMode:=tmModulate;
      end;
      if cmenuitem=1 then
      begin
        Width:=90;
        Height:=90;
      end
      else
      begin
        Width:=60;
        Height:=60;
      end;
      Position.X:=GLSceneViewer1.Width/2;
      Position.Y:=GLSceneViewer1.Height/2;
    end;
    with exitb do
    begin
      fn:=gameexe+'\textures\m1.tga';
      with exitb.Material do
      begin
        Texture.Image.LoadFromFile(fn);
        Texture.Disabled:= false;
        Texture.TextureMode:=tmModulate;
      end;
      if cmenuitem=2 then
      begin
        Width:=90;
        Height:=90;
      end
      else
      begin
        Width:=60;
        Height:=60;
      end;
      Position.X:=GLSceneViewer1.Width/2+90;
      Position.Y:=GLSceneViewer1.Height/2;
    end;
  end;
end;

procedure TForm1.GLFullScreenViewer1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Form1.KeyDown(Key,Shift);
end;

procedure TForm1.GLFullScreenViewer1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Form1.KeyUp(Key,Shift);
end;

end.
